// launchcontrol.js
// Copyright (c) 2009 Kinesys Ltd

var grpHeightMax, grpMoveInc, grpCount, gadgetHeight;
var grpHeight = new Array();
var grpCurrent = 0, grpPrev;
var grpLinkCount;
var grpNames = new Array();
var grpOpens = new Array();
var linkNames = new Array();
var RBLinks = new Array();
var allowMO = false;
var grpTitleHeight = 16;
var tooltipHeight = 2; // 2 or 13

var bgColor, bgImage, grpDelay, hdrClick, showBrdrCrnrs, tooltipLocation, folderFlyout;

var allGrpsOpen = true;
var dragLinkFlag = false;
var dragLinkIdx, dragLinkNewIdx;
var mouseX, mouseY;

function mainInit(){
	var x, f, sTmp, iconGrp, m, m1, m2, m3, grpTmp;
	allowMO = false;
	RBLinks = [];
	grpHeightMax = 0;
	System.Gadget.settingsUI="settings.html";
	launchXML.load(dataPath + "\\launchcontrol.xml");
	System.Gadget.Flyout.onHide = chkInit;
	loadFromXML();
	for(x = 0; x < grpCount; x++){
		grpTmp = document.getElementById("agi" + x)
		grpHeight[x] = grpTmp.scrollHeight + tooltipHeight + 2;
		if(!grpOpens[x] && (grpHeight[x] > grpHeightMax)){
			grpHeightMax = grpHeight[x];
		}
	}
	m = 9;
	m1 = Math.ceil(grpHeightMax / 9) - grpHeightMax / 9;
	m2 = Math.ceil(grpHeightMax / 10) - grpHeightMax / 10;
	m3 = Math.ceil(grpHeightMax / 11) - grpHeightMax / 11;
	if(m2 < m1){
		m1 = m2;
		m = 10;
	}
	if(m3 < m1){
		m = 11;
	}
	grpHeightMax = Math.ceil(grpHeightMax / m) * m + 1;
	grpMoveInc = Math.round(grpHeightMax / m);
	gadgetHeight = 0;
	for(x = 0; x < grpCount; x++){
		iconGrp = document.getElementById("agi" + x);
		gadgetHeight += grpTitleHeight;
		iconGrp.style.height = 1;
		if(grpOpens[x]){
			iconGrp.style.height = grpHeight[x];
			gadgetHeight += grpHeight[x] - 1;
		}else{
			allGrpsOpen = false;
		}
	}
	gadgetHeight += grpTitleHeight + grpCount;
	if(!allGrpsOpen){
		gadgetHeight += grpHeightMax;
	}
	bdyHeight = Math.round((gadgetHeight + 6) / 2) * 2;
	createBorder();
	grpTmp = grpCurrent;
	for(x = 0; x < grpCount; x++){
		if(!grpOpens[x]){
			grpCurrent = x;
			break;
		}
	}
	grpSlide(grpCurrent);
	if(!grpOpens[grpTmp]){
		grpCurrent = grpTmp;
		grpSlide(grpCurrent);
	}
	chkRB();
	setTimeout("allowMO = true;",500);
}

function loadFromXML(){
	var launcher, groups, links, link, x ,y;
	var hdrColor, linkNameColor, iconJustify, hdrJustify, gadgetWidth;
	var rowIcons;
	var iconWidth, iconPadding, iconWidthMO, iconPaddingMO, grpNum;
	var launchHTML = "";
	var btnHTML = "";
	var linkIdx = 0;
	
	launcher = launchXML.getElementsByTagName("launcher")[0];
	bgColor = launcher.getAttribute("bgColor");
	document.getElementById("bg").style.backgroundColor = bgColor;
	bgImage = launcher.getAttribute("bgImage");
	if(bgImage == "[none]"){
		document.getElementById("bg").style.backgroundImage = "";
	}else{
		document.getElementById("bg").style.backgroundImage = "url(/images/backgrounds/" + bgImage + ")";
	}
	hdrColor = launcher.getAttribute("hdrColor");
	if(hdrColor != ""){
		setCSS(".appGrpTitle", "color", hdrColor);
	}
	linkNameColor = launcher.getAttribute("linkNameColor");
	if(linkNameColor != ""){
		setCSS(".linkName", "color", linkNameColor);
	}
	topGrpOpen = false;
	if(launcher.getAttribute("topGrpOpen") == "true"){
		topGrpOpen = true;
	}
	btmGrpOpen = false;
	if(launcher.getAttribute("btmGrpOpen") == "true"){
		btmGrpOpen = true;
	}
	hdrClick = false;
	if(launcher.getAttribute("hdrClick") == "true"){
		hdrClick = true;
	}
	grpDelay = launcher.getAttribute("grpDelay");
	if( grpDelay == ""){
		grpDelay = 0;
	}
	showBrdrCrnrs = false;
	if(launcher.getAttribute("showBrdrCrnrs") == "true"){
		showBrdrCrnrs = true;
	}
	iconJustify = launcher.getAttribute("iconJustify");
	if( iconJustify != ""){
		setCSS(".appGrpIcons", "textAlign", iconJustify);
	}
	hdrJustify = launcher.getAttribute("hdrJustify");
	if( hdrJustify != ""){
		setCSS(".appGrpTitle", "textAlign", hdrJustify);
	}
	tooltipLocation = launcher.getAttribute("tooltipLocation");
	if(tooltipLocation == ""){
		tooltipLocation = "grp";
	}
	if(tooltipLocation == "grp"){
		tooltipHeight = 13;
	}else{
		tooltipHeight = 2;
	}
	folderFlyout = true;
	if(launcher.getAttribute("folderFlyout") == ""){
		folderFlyout = false;
	}
	bdyWidth = 130;
	gadgetWidth = launcher.getAttribute("gadgetWidth");
	if(gadgetWidth > 0){
		bdyWidth = gadgetWidth;
	}
	setCSS(".launcher","width",bdyWidth - 6);
	setCSS(".btns","width",bdyWidth - 6);
	setCSS(".appGrp","width",bdyWidth - 6);
	setCSS(".appGrpTitle","width",bdyWidth - 12);
	setCSS(".appGrpIcons","width",bdyWidth - 10);
	setCSS(".linkName","width",bdyWidth - 12);
	setCSS(".hdrLinkName","width",bdyWidth - 12);
	groups = launchXML.getElementsByTagName("group");
	grpCount = groups.length;
	for(grpNum = 0; grpNum < grpCount; grpNum++){
		rowIcons = groups[grpNum].getAttribute("rowIcons");
		links = groups[grpNum].getElementsByTagName("link");
		grpName = groups[grpNum].getAttribute("name");
		grpNames[grpNum] = grpName;
		if(groups[grpNum].getAttribute("fixedOpen") == "true"){
			grpOpens[grpNum] = true;
		}else{
			grpOpens[grpNum] = false;
		}
		switch (rowIcons) {
			case "2":
				iconWidth = 48;
				iconPadding = 6;
				iconWidthMO = 56;
				iconPaddingMO = 2;
				break;
			case "3":
				iconWidth = 32;
				iconPadding = 4;
				iconWidthMO = 38;
				iconPaddingMO = 1;
				break;
			case "4":
				iconWidth = 24;
				iconPadding = 3;
				iconWidthMO = 28;
				iconPaddingMO = 1;
				break;
			case "5":
				iconWidth = 18;
				iconPadding = 3;
				iconWidthMO = 22;
				iconPaddingMO = 1;
		}
		launchHTML += "<div id=\"ag" + grpNum + "\" class=\"appGrp\" ";
		launchHTML += "ondragenter=\"event.returnValue = false\" ondragover=\"event.returnValue = false\" ";
		launchHTML += "><div id=\"agt" + grpNum + "\" class=\"appGrpTitle\" ";
		launchHTML += "ondrop=\"fileDrop(" + grpNum + ")\" ";
		launchHTML += "ondragenter=\"grpShow(" + grpNum + ")\" ";
		launchHTML += "onclick=\"grpShow(" + grpNum + ")\" ";
		if(!hdrClick){
			launchHTML += "onmouseover=\"grpShow(" + grpNum + ")\" ";
		}
		launchHTML += "><div id=\"aglbl" + grpNum + "\">" + grpName + "</div>";
		launchHTML += "<div class=\"newlink\">";
		launchHTML += "<img src=\"/images/newlink.png\"/ onmouseover=\"this.src='/images/newlink-mo.png'\" ";
		launchHTML += "onmouseout=\"this.src='/images/newlink.png'\" onclick=\"editLink(" + grpNum + ",-1)\"/>";
		launchHTML += "</div></div>";
		launchHTML += "<div id=\"agi" + grpNum + "\" class=\"appGrpIcons\" ";
		launchHTML += "ondrop=\"fileDrop(" + grpNum + ")\" ";
		launchHTML += "onclick=\"linkExec(" + grpNum + ",-1)\" ";
		launchHTML += "onmouseover=\"if(allowMO){grpCurrent=" + grpNum + "}\" ";
		launchHTML += ">";
		for(y = 0; y < links.length; y++){
			linkNames[linkIdx] = getXMLNodeValue(links[y],"linkName");
			linkIcon = chkPath(getXMLNodeValue(links[y],"linkIcon"));
			linkType = links[y].getAttribute("type");
			if(linkIcon == ""){
				linkIcon = chkPath(getXMLNodeValue(links[y],"linkPath"));
			}
			if(linkType == "sep"){
				launchHTML += "<img id=\"icon" + linkIdx + "\" class=\"separator\" src=\"gimage:///" + linkIcon;
				launchHTML += "?width=" + (bdyWidth - 12) + "&height=5\" ";
				launchHTML += "style=\"width:" + (bdyWidth - 12) + "px;height:5px\" ";
			}else{
				launchHTML += "<img id=\"icon" + linkIdx + "\" class=\"icon\" src=\"gimage:///" + linkIcon;
				launchHTML += "?width=48&height=48\" ";
				launchHTML += "style=\"width:" + iconWidth + "px;height:" + iconWidth + "px;padding:" + iconPadding + "px\" ";
			}
			if(linkType == "fly"){
				if(getXMLNodeValue(links[y],"linkPath") == "recyclebin.html"){
					RBLinks[RBLinks.length] = linkIdx;
				}
			}
			launchHTML += "onmouseover=\"linkMouseOver(" + grpNum + "," + linkIdx + ")\" ";
			launchHTML += "onmouseout=\"linkMouseOut(" + grpNum + "," + linkIdx + ")\" ";
			launchHTML += "ondragstart=\"strtDragLink(" + grpNum + "," + linkIdx + ")\" ";
			launchHTML += "onclick=\"linkExec(" + grpNum + "," + linkIdx + ");window.event.returnValue=false\" ";
			launchHTML += "ondrop=\"dropExec(" + grpNum + "," + linkIdx + ")\" />";
			linkIdx++;
		}
		if(tooltipLocation == "grp"){
			launchHTML += "<div id=\"ln" + grpNum + "\" class=\"linkName\"></div>";
		}
		launchHTML += "</div></div>";
	}
	document.getElementById("content").innerHTML = launchHTML;
	if(bdyWidth >= 130){
		btnHTML += "<span class=\"actbtn\" onmouseover=\"btnMOver('btn1')\" onmouseout=\"btnMOut('btn1')\" onclick=\"chkGrpCtrlClick(-1)\">";
		btnHTML += "<img id=\"btn1-hl\" src=\"/images/btn-hl.png\" style=\"visibility:hidden\"/><span id=\"btn1\" class=\"btnlbl\">Grp+</span></span><span ";
		btnHTML += "class=\"actbtn\" onmouseover=\"btnMOver('btn2')\" onmouseout=\"btnMOut('btn2')\" onclick=\"showFlyout('editstyle.html')\">";
		btnHTML += "<img id=\"btn2-hl\" src=\"/images/btn-hl.png\" style=\"visibility:hidden\"/><span id=\"btn2\" class=\"btnlbl\">Style</span></span><span ";
		btnHTML += "class=\"actbtn\" onmouseover=\"btnMOver('btn3')\" onmouseout=\"btnMOut('btn3')\" onclick=\"showFlyout('quickhelp.html')\">";
		btnHTML += "<img id=\"btn3-hl\" src=\"/images/btn-hl.png\" style=\"visibility:hidden\"/><span id=\"btn3\" class=\"btnlbl\">Help</span></span>";
	}else{
		btnHTML += "<span class=\"actbtn\" onmouseover=\"btnMOver('btn1')\" onmouseout=\"btnMOut('btn1')\" onclick=\"chkGrpCtrlClick(-1)\">";
		btnHTML += "<img id=\"btn1-hl\" src=\"/images/btn-hl2.png\" style=\"visibility:hidden\"/><span id=\"btn1\" class=\"btnlbl2\">+</span></span><span ";
		btnHTML += "class=\"actbtn\" onmouseover=\"btnMOver('btn2')\" onmouseout=\"btnMOut('btn2')\" onclick=\"showFlyout('editstyle.html')\">";
		btnHTML += "<img id=\"btn2-hl\" src=\"/images/btn-hl2.png\" style=\"visibility:hidden\"/><span id=\"btn2\" class=\"btnlbl2\">S</span></span><span ";
		btnHTML += "class=\"actbtn\" onmouseover=\"btnMOver('btn3')\" onmouseout=\"btnMOut('btn3')\" onclick=\"showFlyout('quickhelp.html')\">";
		btnHTML += "<img id=\"btn3-hl\" src=\"/images/btn-hl2.png\" style=\"visibility:hidden\"/><span id=\"btn3\" class=\"btnlbl2\">?</span></span>";
	}
	document.getElementById("buttons").innerHTML = btnHTML;
}

function grpSlide(grpNew){
	var grpSlideDone = true;
	var grpShrunkFlg = false;
	var grpNum, iconGrp, newHeight;
	var grpExp = grpCurrent;
	if(grpOpens[grpCurrent]){
		grpExp = grpPrev;
	}	
	for(grpNum = 0; grpNum < grpCount; grpNum++){
		if(!grpOpens[grpNum]){
			iconGrp = document.getElementById("agi" + grpNum)
			newHeight = iconGrp.style.pixelHeight;
			if(grpNum == grpExp){
				if(newHeight < grpHeightMax){
					if(newHeight + grpMoveInc > grpHeightMax){
						newHeight = grpHeightMax;
					}else{
						newHeight += grpMoveInc;
						grpSlideDone = false;
					}
					iconGrp.style.height = newHeight;
				}
			}else{
				if(newHeight > 1 && !grpShrunkFlg){
					grpSlideDone = false;
					grpShrunkFlg = true;
					newHeight -= grpMoveInc;
					if(newHeight < 1){
						newHeight = 1;
					}
					iconGrp.style.height = newHeight;
				}
			}
		}
	}
	if(!grpSlideDone){
		setTimeout("grpSlide(" + grpNew + ")",10);
	}
}

function grpShow(grpNew){
	if(event.ctrlKey){
	 	System.Gadget.Settings.writeString("grpIdx", grpNew);
		showFlyout("editgrp.html");
	}else{
		if((grpNew != grpCurrent) && allowMO){
			grpPrev = grpCurrent;
			grpCurrent = grpNew;
			if(!grpOpens[grpNew]){
				setTimeout("grpSlide(" + grpNew + ")",grpDelay);
			}
		}
	}
}

function chkGrpCtrlClick(grpIdx){
	if(event.ctrlKey || grpIdx == -1){
	 	System.Gadget.Settings.writeString("grpIdx", grpIdx);
		showFlyout("editgrp.html");
	}
}

function linkMouseOver(grpIdx, linkIdx){
	if(linkIdx >= 0 && allowMO){
		grpCurrent = grpIdx;
		var img = document.getElementById("icon" + linkIdx);
		var link = launchXML.getElementsByTagName("link")[linkIdx];
		var linkPath = chkPath(getXMLNodeValue(link,"linkPath"));
		switch(img.style.pixelWidth){
			case 48:
				img.style.width = 56;
				img.style.height = 56;
				img.style.padding = 2;
				break;
			case 32:
				img.style.width = 38;
				img.style.height = 38;
				img.style.padding = 1;
				break;
			case 24:
				img.style.width = 28;
				img.style.height = 28;
				img.style.padding = 1;
				break;
			case 18:
				img.style.width = 22;
				img.style.height = 22;
				img.style.padding = 1;
				break;
		}
		if(tooltipLocation == "hdr"){
			document.getElementById("aglbl" + grpIdx).innerHTML = "<div class=\"hdrLinkName\">" + linkNames[linkIdx] + "</div>";
		}else{
			document.getElementById("ln" + grpIdx).innerHTML = linkNames[linkIdx];
		}
		chkRB();
	}
}

function linkMouseOut(grpIdx,linkIdx){
	if(allowMO){
		var img = document.getElementById("icon" + linkIdx);
		grpCurrent = grpIdx;
		switch(img.style.pixelWidth){
			case 56:
				img.style.width = 48;
				img.style.height = 48;
				img.style.padding = 6;
				break;
			case 38:
				img.style.width = 32;
				img.style.height = 32;
				img.style.padding = 4;
				break;
			case 28:
				img.style.width = 24;
				img.style.height = 24;
				img.style.padding = 3;
				break;
			case 22:
				img.style.width = 18;
				img.style.height = 18;
				img.style.padding = 3;
				break;
		}
		if(tooltipLocation == "hdr"){
			document.getElementById("aglbl" + grpIdx).innerHTML = grpNames[grpIdx];
		}else{
			document.getElementById("ln" + grpIdx).innerHTML = "";
		}
	}
}

function getMouseCoords(){
	var tmp, linkIdx; insBefore = true;
	mouseX = window.event.clientX;
	mouseY = window.event.clientY;
	document.getElementById("dragIcon").style.left = mouseX - 20;
	document.getElementById("dragIcon").style.top = mouseY + 1;
	tmp = window.event.srcElement;
	if(tmp.id.search(/^icon/) == 0){
		linkIdx = tmp.id.substr(4)/1;
		if(tmp.className == "separator"){
			if(window.event.offsetY > 3){
				insBefore = false;
			}
		}else{
			if(window.event.offsetX > getLinkWidth() / 2){
				insBefore = false;
			}
		}
		movePadImg(linkIdx, insBefore);
	}else{
		if(tmp.id.search(/^padImg/) != 0){
			movePadImg(-1,false);
		}
	}
}

function strtDragLink(grpNum,linkIdx){
	var linkImg, padImg, padWidth;
	linkImg = document.getElementById("icon" + linkIdx);
	padWidth = getLinkWidth();
	padImg = document.createElement("img");
	padImg.id = "padImg";
	padImg.src = "/images/blankicon.png";
	padImg.style.width = padWidth;
	padImg.style.height = padWidth;
	padImg.style.position = "relative";
	dragLinkFlag = true;
	dragLinkIdx = linkIdx;
	document.onmousemove = getMouseCoords;
	document.onmouseup = linkDrop;
	document.onkeypress = chkCancelDrag;
	linkImg.style.display = "none";
	linkImg.insertAdjacentElement("afterEnd",padImg);
	imgSrc = linkImg.src;
	document.getElementById("dragIcon").innerHTML = "<img src=\"" + imgSrc + "\" style=\"width:18px\"/>";
	return true;
}

function getLastLinkIdx(){
	var x, idx, lastLinkIdx = 0;
	var linkGrp = document.getElementById("agi" + grpCurrent)
	var links = linkGrp.getElementsByTagName("img");
	for(x = 0; x < links.length; x++){
		if(links[x].id.search(/^icon/) == 0){
			idx = links[x].id.substr(4)/1;
			if(idx > lastLinkIdx){
				lastLinkIdx = idx;
			}
		}
	}
	return lastLinkIdx;
}


function movePadImg(linkIdx, insBefore){
	if(dragLinkFlag){
		var padImgNew, padWidth, linkGrp, lastLinkIdx, linkImg;

		lastLinkIdx = getLastLinkIdx();
		padWidth = getLinkWidth();
		if(linkIdx != -1){
			if(!insBefore){
				linkIdx++;
			}
			if(linkIdx > lastLinkIdx){
				linkIdx = -1;
			}
		}
		if(linkIdx != dragLinkNewIdx){
			padImgNew = document.createElement("img");
			padImgNew.id = "padImgNew";
			padImgNew.src = "/images/blankicon.png";
			padImgNew.style.width = padWidth;
			padImgNew.style.height = padWidth;
			padImgNew.style.position = "relative";
			if(linkIdx == -1){
				linkImg = document.getElementById("icon" + lastLinkIdx);
				linkImg.insertAdjacentElement("afterEnd",padImgNew);
			}else{
				linkImg = document.getElementById("icon" + linkIdx);
				linkImg.insertAdjacentElement("beforeBegin",padImgNew);
			}
			dragLinkNewIdx = linkIdx;
			document.getElementById("padImgNew").style.width = padWidth;
			document.getElementById("padImgNew").style.height = padWidth;
			document.getElementById("padImg").removeNode();
			document.getElementById("padImgNew").id = "padImg";
		}
	}
}

function linkDrop(){
	var oldLink, newLink, groups, link;
	allowMO = false;
	cancelDrag();
	oldLink = launchXML.getElementsByTagName("link")[dragLinkIdx];
	newLink = oldLink.cloneNode(true);
	if(dragLinkNewIdx >= 0){
		link = launchXML.getElementsByTagName("link")[dragLinkNewIdx];
		link.parentNode.insertBefore(newLink,link);
	}else{
		group = launchXML.getElementsByTagName("group")[grpCurrent];
		group.appendChild(newLink);
	}
	oldLink.parentNode.removeChild(oldLink);
	launchXML.save(dataPath + "\\launchcontrol.xml");
	mainInit();
}

function chkCancelDrag(){
	if(window.event.keyCode == 27){
		cancelDrag();
	}
}

function cancelDrag(){
	document.onmouseup = null;
	document.onmousemove = null;
	document.onkeypress = null;
	dragLinkFlag = false;
	if(document.getElementById("padImg")){
		document.getElementById("padImg").removeNode();
	}
	document.getElementById("icon" + dragLinkIdx).style.display = "inline";
	document.getElementById("dragIcon").innerHTML = "";
}

function getLinkWidth(){
	var padWidth;
	var groups = launchXML.getElementsByTagName("group");
	var	rowIcons = groups[grpCurrent].getAttribute("rowIcons");
	switch(rowIcons){
		case "2": padWidth = 60; break;
		case "3": padWidth = 40; break;
		case "4": padWidth = 30; break;
		case "5": padWidth = 24; break;
	}
	return padWidth;
}

function editLink(grpNum,linkIdx){
 	System.Gadget.Settings.writeString("linkIdx", linkIdx);
 	System.Gadget.Settings.writeString("grpIdx", grpNum);
	showFlyout("editlink.html");
	event.cancelBubble = true;
}

function linkExec(grpNum,linkIdx){
	if(event.ctrlKey){
		editLink(grpNum,linkIdx);
	}else{
		if(linkIdx >= 0){
			var link = launchXML.getElementsByTagName("link")[linkIdx];
			var linkPath = chkPath(getXMLNodeValue(link,"linkPath"));
			var linkType = link.getAttribute("type");
			var linkArgs = getXMLNodeValue(link,"linkArgs");
			var linkDir = getXMLNodeValue(link,"linkDir");
			if(linkType == "fly"){
				showFlyout(linkPath);
			}else{
				var tmp = System.Shell.itemFromPath(linkPath)
				if(tmp.isFolder && linkType != "app" && folderFlyout){
					System.Gadget.Settings.writeString("linkPath", tmp.path);
					showFlyout("viewfldr.html");
				}else{
					System.Shell.execute(linkPath, linkArgs, linkDir);
				}
			}
		}
	}
	event.cancelBubble = true;
}

function dropExec(grpNum,linkIdx){
	var idx = 0, item, tmp;
	var link = launchXML.getElementsByTagName("link")[linkIdx];
	var linkPath = chkPath(getXMLNodeValue(link,"linkPath"));
	var linkType = link.getAttribute("type");
	var linkArgs = "";
	var linkDir = getXMLNodeValue(link,"linkDir");
	var linkOp = "open";
	while(item = System.Shell.itemFromFileDrop(event.dataTransfer, idx)){
		switch(linkType){
			case "fld":
				folder = tmp.SHFolder;
				folder.copyHere(item,0);
				break;
			case "app":
				linkArgs = "\"" + item.path + "\"";
				System.Shell.execute(linkPath, linkArgs, linkDir, linkOp);
				break;
			case "fly":
				if(linkPath = "recyclebin.html"){
					System.Shell.RecycleBin.deleteItem(item.path);
				}
				chkRB();
				break;
		}
		idx++;
	}
	event.cancelBubble = true;
}

function fileDrop(grpNum){
	var idx = 0;
	var item, itmExt, idx, linkName = "", linkType = "", linkPath, linkDir = "", linkArgs = "", linkIcon = "", oShellLink;
	var tmp, x, err, iconLoc = "", iconIdx = 0, filNam = "", filExt = "";

	if(!System.Shell.itemFromFileDrop(event.dataTransfer, idx)){
		linkPath = event.dataTransfer.getData("text");
		tmp = linkPath.match(/^http[s]?:\/\/([^\/]*)/);
		if(tmp instanceof Array ){
			linkIcon = "%Gadget%\\images\\icons\\url.ico";
			linkType = "url";
		}
		addLink(grpNum,linkName,linkType,linkPath,linkDir,linkArgs,linkIcon);
	}else{
		while(item = System.Shell.itemFromFileDrop(event.dataTransfer, idx)){
			linkName = item.name;
			tmp = item.path.match(/.*\.([^\.]*)/);
			if(tmp instanceof Array ){
				itmExt = tmp[1];
			}else{
				itmExt = "";
			}
			if(item.isLink){
				oShellLink = WSShell.CreateShortcut(item.path);
				if(event.ctrlKey){
					linkPath = dataPath + "\\shortcuts\\" + linkName + ".lnk";
					fso.CopyFile(chkPath(item.path), linkPath);
				}else{
					linkPath = chkPath(oShellLink.TargetPath);
				}
				if(itmExt.toLowerCase() == "url"){
					linkIcon = gadgetPath + "\\images\\icons\\url.ico";
				}else{
					tmp = linkPath.match(/.*\\([^\\]*)\.([^\\]*)/);
					if(tmp != null){
						filNam = tmp[1];
						filExt = tmp[2];
					}else{
						filNam = linkName;
					}
					if(oShellLink.IconLocation != ""){
						iconLoc = chkPath(oShellLink.IconLocation);
						if(iconLoc.search(",") >= 0){
							tmp = iconLoc.match(/([^,]*),([^,]*)/);
							iconLoc = tmp[1];
							iconIdx = tmp[2];
							if(iconLoc == ""){
								iconLoc = linkPath;
							}
							if(iconLoc != linkPath || iconIdx != 0){
								err = getRsrc(iconLoc);
								if(err >= 0){
									err = saveIconGroup(iconIdx,dataPath + "\\icons\\" + linkName + ".ico");
									if(err >= 0){
										iconLoc = dataPath + "\\icons\\" + linkName + ".ico";
									}
								}
							}
						}
						linkIcon = iconLoc;
					}
					if(!event.ctrlKey){
						linkDir = chkPath(oShellLink.WorkingDirectory);
						linkArgs = oShellLink.Arguments;
					}
				}
			}else{
				linkPath = item.path;
			}
			addLink(grpNum,linkName,"app",linkPath,linkDir,linkArgs,linkIcon);
			idx++;
		}
	}
}

function addLink(grpNum,linkName,linkType,linkPath,linkDir,linkArgs,linkIcon){
	var id, link, tmp;
	var group = launchXML.getElementsByTagName("group")[grpNum];
	var newLink = launchXML.createElement("link");
	group.appendChild(newLink);
	id = group.getElementsByTagName("link").length - 1;
	link = group.getElementsByTagName("link")[id];
	if(linkType != "sep" && linkType != "fly"){
		tmp = System.Shell.itemFromPath(linkPath)
		if(tmp.isFolder){
			linkType = "fld";
		}
	}
	link.setAttribute("type",linkType);
	updXMLTextNode(launchXML,link,"linkName",linkName);
	updXMLTextNode(launchXML,link,"linkPath",linkPath);
	updXMLTextNode(launchXML,link,"linkDir",linkDir);
	updXMLTextNode(launchXML,link,"linkArgs",linkArgs);
	updXMLTextNode(launchXML,link,"linkIcon",linkIcon);
	launchXML.save(dataPath + "\\launchcontrol.xml");
	mainInit();
}

function showFlyout(page){
	System.Gadget.Flyout.file = "/" + page;
	System.Gadget.Flyout.show = true;
}

function chkInit(){
	if(System.Gadget.Settings.read("initGadget")){
		mainInit();
	}else{
		chkRB();
	}
}

function chkRB(){
	var linkIcon = chkPath("gimage:///%Gadget%\\images\\icons\\");
	var x;
	if(System.Shell.RecycleBin.fileCount != 0 || System.Shell.RecycleBin.folderCount != 0){
		linkIcon += "recycle bin full.ico";
	}else{
		linkIcon += "recycle bin empty.ico";
	}
	linkIcon += "?width=48&height=48";
	for(x = 0; x < RBLinks.length; x++){
		document.getElementById("icon" + RBLinks[x]).src = linkIcon;
	}
}

function btnMOver(btn){
	document.getElementById(btn + "-hl").style.visibility = "visible";
	document.getElementById(btn).style.color = 'white';
}

function btnMOut(btn){
	document.getElementById(btn + "-hl").style.visibility = "hidden";
	document.getElementById(btn).style.color = "#b0b0b0";
}
