// External variables:

// skinPath		- String, relative path of this theme, from System.Gadget.path ie "themes\default"
//				  use this when pulling in graphics.  ie src='" + skinPath + "/graphics.png'"
// EQbands		- Integer, the number of EQ bands the Gadget is configured for
// decayRate	- Integer, the current decayRate setting (0 to 20)
// divGraph		- the DIV to create the display elements in
// bDebug		- Boolean, is the Gadget in debug mode


// External methods:
// debugLog(<text>)	- write a debug log entry
// EQGadget.EQBand([0...<EQbands>]) - Integer, the power spectrum results



// Methods to be included in this code:

// initialize()	- initialize the graphics, setup variables etc
//                you must set the document.body.style.width/height in here
// display()	- display the EQ.  A call should be made to "EQGadget.FFT(EQbands);"
//				  to run an FFT on the current sound output.



var gWidth = 130;			// gadget width
var gHeight = 65;			// gadget height

var maxImages = 100;

if (System.Gadget.Settings.readString("default_barStyle") != "")
	var barStyle = System.Gadget.Settings.read("default_barStyle");
else
	var barStyle = 1;			// the filename of the bar style

if (System.Gadget.Settings.readString("default_backgroundStyle") != "")
	var backgroundStyle = System.Gadget.Settings.read("default_backgroundStyle");
else
	var backgroundStyle = 0;	// the filename of the background style
var nextBackgroundStyle = backgroundStyle;

var barWidth = 6;			// width of the bar
var barHeight = 49;		// the max height of the bars
var eqBars = new Array(EQbands);

var updating = false;
var background = new Array(1);
var gBackgroundChanger, gBarBackground, gBarChanger;

function initialize() {
	var xPos, yPos, obj, obj1;

	document.body.style.width = gWidth;
	document.body.style.height = gHeight;

	//set the background if it exists
	divGraph.innerHTML += "<g:background id='gbackground' src='images/blank.png' style='top:0px; left:0px; width:" + gWidth + "px; height:" + gHeight + "px;' />";
	divGraph.innerHTML += "<img src='images/blank.png' style='top:10px; left:108px; width:14px; height:14px;' " +
		"onclick=\"fadeBackground(); changeIMG(gBackgroundChanger, 'backgroundClickHover.png')\" " +
		"onmousedown=\"changeIMG(gBackgroundChanger, 'backgroundClickDown.png')\" " +
		"onmouseover=\"changeIMG(gBackgroundChanger, 'backgroundClickHover.png')\" " +
		"onmouseout =\"changeIMG(gBackgroundChanger, 'backgroundClick.png')\" " +
		"title=\"Change background\" />";
	divGraph.innerHTML += "<img src='images/blank.png' style='top:40px; left:107px; width:14px; height:14px;' " +
		"onclick=\"fadeBar(); changeIMG(gBarChanger, 'barClickHover.png')\" " +
		"onmousedown=\"changeIMG(gBarChanger, 'barClickDown.png')\" " +
		"onmouseover=\"changeIMG(gBarChanger, 'barClickHover.png')\" " +
		"onmouseout =\"changeIMG(gBarChanger, 'barClick.png')\" " +
		"title=\"Change bars\" />";

	//create the EQ bar elements
	for (var j = 0; j < EQbands; j++) {
		xPos = 8 + j * barWidth;
		yPos = 8;

		// EQ band itself
		divGraph.innerHTML += "<div id='divEQband" + j + "' style='position:absolute;" +
			"overflow:hidden; width:" + barWidth + "px;" +
			"top:" + yPos + "px; " + "left:" + xPos + "px;'><img id='imgEQband" + j + "' " +
			"src='" + skinPath + "/bars/bar" + barStyle + ".png' style='position:absolute' /></div>";
	}

	initArray();
	window.setTimeout(setupBackground, 1);
}


function fadeBar() {
try{
	barStyle++;
	if (!oFSO.FileExists(System.Gadget.path + "\\" + skinPath + "\\bars\\bar" + barStyle + ".png"))
		barStyle = 1;

	//save setting
	System.Gadget.Settings.write("default_barStyle", barStyle)

	gBarBackground.src = skinPath + "\\bars\\bar" + barStyle + "background.png"
	for (var j=0; j<EQbands; j++) {
		obj = document.getElementById("imgEQband" + j);
		obj.src = skinPath + "/bars/bar" + barStyle + ".png";
	}
} catch(err) {debugLog("fadeBar: " + err.name + " - " + err.message)}
}

function changeIMG(obj, img) {
	obj.src = skinPath + "/" + img;
}

function setupBackground() {
try{
	background[0] = gbackground.addImageObject(nextBackground(), 4, 4);
	background[0].opacity = 0;
	background[0].width = 121;
	background[0].height = 57;
	background[1] = gbackground.addImageObject(aImages[backgroundStyle], 4, 4);
	background[1].opacity = 100;
	background[1].width = 121;
	background[1].height = 57;

	gBackgroundChanger = gbackground.addImageObject(skinPath + "/backgroundClick.png", 108, 10);
	gBarChanger = gbackground.addImageObject(skinPath + "/barClick.png", 107, 40);
	gBarBackground = gbackground.addImageObject(skinPath + "/bars/bar" + barStyle + "background.png", 0, 0);
} catch(err) {debugLog("setupBackground: " + err.name + " - " + err.message)}
}


function nextBackground(change) {
	nextBackgroundStyle++;
	if (nextBackgroundStyle < aImages.length) {
		if (change) {
			if (nextBackgroundStyle == 1)
				backgroundStyle = 0;
			else
				backgroundStyle++;
		}
	} else {
		if (change) backgroundStyle = nextBackgroundStyle-1;
		nextBackgroundStyle = 0;
	}

	return aImages[nextBackgroundStyle];
}

function backgroundStylePlus1() {
	backgroundStyle++;
	return backgroundStyle;
}

function fadeBackground() {
try{
	if (background[0].opacity < 100) {
		background[0].opacity += 10;
		background[1].opacity -= 10;
		window.setTimeout(fadeBackground, 20);
	} else {
		background[1].src = background[0].src;
		background[0].opacity = 0;
		background[1].opacity = 100;
		background[0].src = nextBackground(true);

		//save settings
		System.Gadget.Settings.write("default_backgroundStyle", backgroundStyle);
	}
} catch(err) {debugLog("fadeBackground: " + err.name + " - " + err.message)}
}




function display() {
	if (updating) return;
	updating = true;

	var eqScale, obj;

	// update the EQ
	for (var j = 0; j < EQbands; j++) {
		try{
			eqScale = parseInt(EQGadget.EQBand(j) * (barHeight/100));
			if (eqScale > barHeight) eqScale = barHeight;
		} catch(err) {
			if (bDebug) debugLog("display1: "+err.name+" - "+err.message);
			eqScale = 0;
		}
		try{
			//decay the bars
			if (decayRate > 0) {
				if (eqScale < eqBars[j]) 
					if (eqBars[j] - decayRate > eqScale)
						eqScale = eqBars[j] - decayRate;
			}

			obj = document.getElementById("divEQband" + j);
			if (eqScale < 1) {
				// hide the bar if it's zero
				if (eqBars[j] > 0) obj.style.display = "none";
			} else {
				// display the bar if it's hidden
				if (eqBars[j] < 1) obj.style.display = "inline";
	
				// update the bar height
				var tHeight = barHeight - eqScale;
				obj.style.height = eqScale;
				obj.style.top = 8 + tHeight;
				obj = document.getElementById("imgEQband" + j);
				
				// convert to a string to get around a bug on 64bit IE7
				obj.style.top = String(-tHeight) + "px";
			}
		} catch(err) {debugLog("display2: "+err.name+" - "+err.message)}

		eqBars[j] = eqScale;
	}

	updating = false;
}



// Initialize the image array
var supportedFileTypes = " .jpg .jpeg .jpe .gif .png .bmp ";
var aImages;

function initArray() {
try{
	aImages = new Array();
	catalogueImages(System.Gadget.path + "\\" + skinPath.replace(RegExp("/", "g"), "\\") + "\\backgrounds");

	//if there's no images, use the windows wallpaper folder
	if (aImages.length == 0) {
		currentPath = System.Environment.getEnvironmentVariable("WINDIR") + "\\Web\\Wallpaper";
		catalogueImages(currentPath);
	}
} catch(err) {debugLog("initArray:"+err.name+" - "+err.message)}
}



// Catalogue the images in the selected folder
function catalogueImages(filePath) {
	//stop getting images if we have too many
	if (aImages.length >= maxImages) return;

	//get the folder
	try{
		var oFolder = System.Shell.itemFromPath(filePath); 
	} catch(err) {debugLog("catalogueImages: "+err.name+" - "+err.message); return;}

	try{
		//dont look in compressed folders
		if(oFolder.type == "Compressed (zipped) Folder") return;
	
		//get the files in the folder
		var oItems = oFolder.SHFolder.Items;
		var sFiletype;
	
		var imageCount = oItems.count;
	
		for(var i = 0; i<imageCount && aImages.length<maxImages; i++)
		{
			var sFile = oItems.item(i).path;
			if (bDebug) debugLog("file: "+sFile);
	
			if(!oItems.item(i).isFolder && !oItems.item(i).isLink)
	        {
	        	//file
				sFiletype = sFile.substr(sFile.lastIndexOf(".")).toLowerCase();
	            if(supportedFileTypes.indexOf(" " + sFiletype + " ") > -1)
					aImages.push(sFile);
	        }
	    }
	} catch(err) {debugLog("catalogueImages: "+err.name+" - "+err.message)}
}