// GREEN - PEAK

// External variables:

// skinPath    - String, relative path of this theme, from System.Gadget.path ie "themes\default"
//            use this when pulling in graphics.  ie src='" + skinPath + "/graphics.png'"
// EQbands     - Integer, the number of EQ bands the Gadget is configured for
// myDecayRate   - Integer, the current decayRate setting (0 to 20)
// divGraph    - the DIV to create the display elements in
// bDebug      - Boolean, is the Gadget in debug mode


// External methods:
// debugLog(<text>)  - write a debug log entry
// EQGadget.FFT(EQbands) - Perform an FFT on the current sound output
// EQGadget.EQBand([0...<EQbands>]) - Integer, the power spectrum results



// Variable to be included in this code:

// gWidth   - Integer, Gadget width
// gHeight  - Integer, Gadget height


// Methods to be included in this code:

// initialize()   - initialize the graphics, setup variables etc
// display()   - display the EQ.  A call should be made to "EQGadget.FFT(EQbands);"
//            to run an FFT on the current sound output.



var gWidth = 200;       // gadget width
var gHeight = 112;         // gadget height


var barWidth = 12;         // width of the bar
var barHeight = 101;    // the max height of the bars
var eqBars = new Array(EQbands);
var eqPeak = new Array(EQbands);
var peakTmr = new Array(EQbands);

var updating = false;
var scaledBarHeight = barHeight/100;
var myZoom = 0.63;


function initialize() {
   var xPos, yPos;

document.body.style.width = gWidth * myZoom;
document.body.style.height = gHeight * myZoom;
document.body.style.zoom = myZoom;

        // black background because Gadget.System.background is retarded
      divGraph.innerHTML += "<div style='width:190px; top:5px; left:5px;'>" +
         "<img src='" + skinPath + "/peak_background.png' /></div>";

   //create the EQ bar elements
   for (j = 0; j < EQbands; j++) {
      xPos = 5 + j * barWidth;
      yPos = 5;

      // EQ band itself
      divGraph.innerHTML += "<div id='divEQpeak" + j + "' style='overflow:hidden; width:" + barWidth +
         "px; top:" + yPos + "px; " + "left:" + xPos + "px;'>" +
         "<img id='imgEQpeak" + j + "' src='" + skinPath + "/peak.png' /></div>";
      // each peak hold
      divGraph.innerHTML += "<div id='divEQband" + j + "' style='overflow:hidden; width:" + barWidth +
         "px; top:" + yPos + "px; " + "left:" + xPos + "px;'>" +
         "<img id='imgEQband" + j + "' src='" + skinPath + "/bar1.png' /></div>";
   }

   System.Gadget.background = skinPath + "/bar1_background.png";
}




function display() {
   if (updating) return;
   updating = true;
   
   var eqBarScale, eqPeakScale, obj;
   try{
      // quick test if work needed
      var nonZeroCount = 0;
      for (j=0; j < EQbands; j++)
      {
          if ( parseInt( scaledBarHeight * EQGadget.EQBand(j)) > 0)
               nonZeroCount ++ ;
          if ( eqPeak[j] > 0 )
               nonZeroCount ++ ;
      }
      if ( nonZeroCount > 0  )
      {
         if ( decayRate == 0)
         {
            myDecayRate = 20;
            peakDelay = 16;
            peakDecayRate = 10;
         }
         else
         {
            myDecayRate = (decayRate + 1) * 2;
            if ( myDecayRate > 16)
               myDecayRate = 16;
            peakDelay = (decayRate + 1) * 3 + 4;
            if ( peakDelay > 16)
               peakDelay = 16;
            if ( peakDelay < 4)
               peakDelay = 4;
            peakDecayRate = myDecayRate/2;
         }

          // update the EQ
          for (j = 0; j < EQbands; j++) {

             eqBarScale = scaledBarHeight * EQGadget.EQBand(j);
             eqPeakScale = eqBarScale;

             if (eqBarScale > 0)
             {
                  eqBarScale += 2;

                  if (eqBarScale < barHeight/4)
                    eqBarScale *= 2;

                 eqPeakScale = eqBarScale + 4;
             }

             if (eqPeakScale > barHeight) 
                eqPeakScale = barHeight;

             if (eqBarScale > barHeight)
                eqBarScale = barHeight - 4;


             //decay the bars
            if (eqBarScale < eqBars[j] - myDecayRate)
               eqBarScale = eqBars[j] - myDecayRate ;

            if (eqPeakScale < eqPeak[j] - peakDecayRate)
            {
              peakTmr[j]--;
              eqPeakScale = eqPeak[j] - peakDecayRate ;
            }
            else
            {
              peakTmr[j] = peakDelay;
            }

            // update the display
              obj = document.getElementById("divEQband" + j);
              if (eqBarScale < 1) {
                 // hide the bar if it's zero
                 if (eqBars[j] > 0) obj.style.display = "none";
              } else {
                 // display the bar if it's hidden
                 if (eqBars[j] < 1) obj.style.display = "inline";

                 // update the bar height
                 var tHeight = barHeight - eqBarScale;
                 obj.style.height = eqBarScale;
                 obj.style.top = 5 + tHeight;
                 obj = document.getElementById("imgEQband" + j);
                 obj.style.top = -tHeight;
              }
              eqBars[j] = eqBarScale;

              if ( (peakTmr[j] < 0) || (peakTmr[j] == peakDelay))
              {
                   obj = document.getElementById("divEQpeak" + j);
                   if (eqPeakScale < 1) {
                      // hide the bar if it's zero
                      if (eqPeak[j] > 0) obj.style.display = "none";
                   } else {
                      // display the bar if it's hidden
                      if (eqPeak[j] < 1) obj.style.display = "inline";

                      // update the bar height
                      var tHeight = barHeight - eqPeakScale;
                      obj.style.height = eqPeakScale ;
                      obj.style.top = 5 + tHeight;
                   }
                   eqPeak[j] = eqPeakScale;
               }
          }
      }
   } catch(err) {debugLog("display: "+err.name+" - "+err.message)}

   updating = false;
}
