﻿/*
//-------------------------------------------------------------------------------------
//  THIS CODE IS NOT APPROVED FOR USE IN/ON ANY OTHER UI ELEMENT OR PRODUCT COMPONENT.  
//  Copyright (c)2007 Stedy Software and Systems.  All rights reserved.
// ------------------------------------------------------------------------------------
*/

// declarations
var olAppointmentItem = 1;                  // Represents an AppointmentItem 
var olContactItem = 2;                      // Represents a ContactItem 
var olDistributionListItem = 7;             // Represents an DistListItem 
var olJournalItem = 4;                      // Represents a JournalItem 
var olMailItem = 0;                         // Represents a MailItem 
var olNoteItem = 5;                         // Represents a NoteItem 
var olPostItem = 6;                         // Represents a PostItem 
var olTaskItem = 3;                         // Represents a TaskItem 

var olFolderCalendar = 9;                   // The Calendar folder. 
var olFolderConflicts = 19;                 // The Conflicts folder (subfolder of Sync Issues folder). Only available for an Exchange account. 
var olFolderContacts = 10;                  // The Contacts folder. 
var olFolderDeletedItems = 3;               // The Deleted Items folder. 
var olFolderDrafts = 16;                    // The Drafts folder. 
var olFolderInbox = 6;                      // The Inbox folder. 
var olFolderJournal = 11;                   // The Journal folder. 
var olFolderJunk = 23;                      // The Junk E-Mail folder. 
var olFolderLocalFailures = 21;             // The Local Failures folder (subfolder of Sync Issues folder). Only available for an Exchange account. 
var olFolderManagedEmail = 29;              // The top-level folder in the Managed Folders group. For more information on Managed Folders, see Help in Microsoft Office Outlook. Only available for an Exchange account. 
var olFolderNotes = 12;                     // The Notes folder. 
var olFolderOutbox = 4;                     // The Outbox folder. 
var olFolderSentMail = 5;                   // The Sent Mail folder. 
var olFolderServerFailures = 22;            // The Server Failures folder (subfolder of Sync Issues folder). Only available for an Exchange account. 
var olFolderSyncIssues = 20;                // The Sync Issues folder. Only available for an Exchange account. 
var olFolderTasks = 13;                     // The Tasks folder. 
var olFolderToDo = 28;                      // The To Do folder. 
var olPublicFoldersAllPublicFolders = 18;   // The All Public Folders folder in the Exchange Public Folders store. Only available for an Exchange account. 
var olFolderRssFeeds = 25;                  // The RSS Feeds folder. 

var objOutlook = null;
var objMapi = null;

var maxEmails = 10;

var syncInterval = 300000;
var objSyncTimer = null;

var refreshInterval = 3000;
var objRefreshTimer = null;

var objFolder = null;
var objFolderItems = null;
var objSelectedMessage = null;

var elFolderName = null;
var elUnreadCount = null;
var elContainer = null;
var elBackground = null;
var elSelectedMessage = null;

var unreadCount = 0;
var objScrollTimer = null;
var scrollDirection = "";

var errorMessage = "";

// constructor
function initGadget() {
    try {
        elBackground = document.getElementById("sboBg");
        elUnreadCount = document.getElementById("unreadCount");
        elContainer = document.getElementById("container");
        
	    setDockState();

	    System.Gadget.onDock = dockGadget;
	    System.Gadget.onUndock = undockGadget;
        System.Gadget.settingsUI = "settings.html";
        System.Gadget.onSettingsClosed = settingsClosed;
        System.Gadget.Flyout.file = "flyout.html";
        System.Gadget.Flyout.onShow = flyoutShow;
        System.Gadget.Flyout.onHide = flyoutHide;

        objOutlook = new ActiveXObject("Outlook.Application");
        objMapi = objOutlook.getNameSpace("MAPI");

        maxEmails = parseInt(System.Gadget.Settings.read("maxEmails"));
        if(isNaN(maxEmails)) { maxEmails = 10; }
        refreshInterval = parseInt(System.Gadget.Settings.read("refreshInterval"));
        if(isNaN(refreshInterval)) { refreshInterval = 3000; }
        objRefreshTimer = setTimeout("refreshFolder()", refreshInterval);
        syncInterval = parseInt(System.Gadget.Settings.read("syncInterval"));
        if(isNaN(syncInterval)) { syncInterval = 300000; }
        objSyncTimer = setTimeout("syncOutlookFolder()", syncInterval);
    }
    catch(err) {   
        errorMessage = err.name + " - " + err.message;
    }
}

// private functions
function setDockState()
{
    if (System.Gadget.docked) {
        dockGadget();
    }
    else {
        undockGadget();
    }
}

function openOutlookFolder() {
    clearTimeout(objRefreshTimer);
    if (System.Gadget.Flyout.show == true) { HideFlyout(); }
    try {
        objActiveExplorer = objOutlook.ActiveExplorer;
        if (objActiveExplorer != null) {
            objCurrentFolder = objActiveExplorer.CurrentFolder;
            if (objCurrentFolder != null) {
                objFolder = objCurrentFolder;
                elBackground.removeObjects();
                elBackground.addTextObject(objFolder.Name, 'Calibri', 12, 'white', 22, 2);
                System.Gadget.Settings.write("EntryId", objFolder.EntryId);
                System.Gadget.Settings.write("StoreId", objFolder.StoreId);
                refreshOutlookFolderItems();
            }
            else {
                errorMessage = "Type Error - Outlook does not have a selected folder!";
            }
        }
        else {
            errorMessage = "Type Error - Outlook is currently not open!";
        }
    }
    catch(err) {
        errorMessage = err.name + " - " + err.message;
    }
}

function selectOutlookFolder() {
    clearTimeout(objRefreshTimer);
    if (System.Gadget.Flyout.show == true) { HideFlyout(); }
    try {
        objFolder = pickOutlookFolder();
        elBackground.removeObjects();
        elBackground.addTextObject(objFolder.Name, 'Calibri', 12, 'white', 22, 2);
        System.Gadget.Settings.write("EntryId", objFolder.EntryId);
        System.Gadget.Settings.write("StoreId", objFolder.StoreId);
        refreshOutlookFolderItems();
    }
    catch(err) {
        errorMessage = err.name + " - " + err.message;
    }
}


function pickOutlookFolder() {
    var objOutlookFolder = objMapi.PickFolder();
    if (objOutlookFolder == null) {
        errorMessage = "Type Error - You must select a valid mail folder!";
    }
    else {
        if(objOutlookFolder.DefaultItemType != olMailItem) {
            errorMessage = "Type Error - You must select a valid mail folder!";
            objOutlookFolder = null;
        }
    }
    return objOutlookFolder;
}

function setOutlookFolder() {
    try {
        var EntryId = System.Gadget.Settings.read("EntryId");
        var StoreId = System.Gadget.Settings.read("StoreId");
        if((EntryId != null && EntryId.length > 0) && (StoreId != null && StoreId.length > 0)) {
            objFolder = objMapi.GetFolderFromId(EntryId, StoreId);
        }
        else {
            objActiveExplorer = objOutlook.ActiveExplorer;
            if (objActiveExplorer != null) {
                objCurrentFolder = objActiveExplorer.CurrentFolder;
                if (objCurrentFolder != null) {
                    objFolder = objCurrentFolder;
                }
            }
            if (objFolder == null) {
                objFolder = objMapi.GetDefaultFolder(olFolderInbox);
            }
        }
    }
    catch(err) {
        try {
            objFolder = objMapi.GetDefaultFolder(olFolderInbox);
        }
        catch(err) {
            objFolder = pickOutlookFolder();
        }
    }
    elBackground.removeObjects();
    elBackground.addTextObject(objFolder.Name, 'Calibri', 12, 'white', 22, 2);
    System.Gadget.Settings.write("EntryId", objFolder.EntryId);
    System.Gadget.Settings.write("StoreId", objFolder.StoreId);
}

function syncOutlookFolder() {
    clearTimeout(objRefreshTimer);
    try {
        objMapi.SendAndReceive(false);
    }
    catch(err) {
        try {
            var objSyncs = objMapi.SyncObjects;
            var objSync = objSyncs.AppFolders;
            objFolder = objMapi.GetDefaultFolder(olFolderInbox);
            objFolder.InAppFolderSyncObject = true;
            objSync.Start();
        }
        catch(err) {
            errorMessage = err.name + " - " + err.message;
            return;
        }
    }
    objRefreshTimer = setTimeout("refreshFolder()", refreshInterval);
}

function refreshOutlookFolderItems() {
    clearTimeout(objRefreshTimer);
    if (objFolder == null) {
        setOutlookFolder();
    }
    try {
        unreadCount = objFolder.UnReadItemCount;
        objFolderItems = objFolder.Items;
        objFolderItems.Sort("[ReceivedTime]", true);
        var result = updateHtmlFolderItems();
    }
    catch(err) {
        unreadCount = 0;
    }
    elUnreadCount.innerText = unreadCount;
    document.getElementById("btnErrorMessage").style.visibility = (errorMessage == "" ? "hidden" : "visible");
    objRefreshTimer = setTimeout("refreshFolder()", refreshInterval);
}

function updateHtmlFolderItems() {
    try {
        for (var i = 1; i <= objFolderItems.Count; i++) {
            var addItem = false;
            var mailItem = objFolderItems(i);
            
            var nodeItem = null;
            var nodeItems = elContainer.all.tags("div");
            if (nodeItems != null) {
                nodeItem = nodeItems[i - 1];
                if (nodeItem == null) {
                    addItem = true;
                    nodeItem = document.createElement("div");
                    nodeItem.id = "mailItem";
                    nodeItem.style.display = "block";
                }
            }
            else {
                addItem = true;
                nodeItem = document.createElement("div");
                nodeItem.id = "mailItem";
                nodeItem.style.display = "block";
            }
           
            nodeItem.messageIdx = i;
            nodeItem.entryId = mailItem.EntryID;
            nodeItem.unread = mailItem.UnRead;
            nodeItem.className = (nodeItem.unread ? "unread" : "");
          
            var fromSpan = null;
            var sn = mailItem.SenderName;
            if (addItem) {
                fromSpan = document.createElement("span");
                fromSpan.id = "from";
                fromSpan.innerText = sn;
                nodeItem.appendChild(fromSpan);
            }
            else {
                fromSpan = nodeItem.children[0];
                fromSpan.innerText = sn;
            }
            
            var dateSpan = null;
            var dt = formatDate(mailItem.ReceivedTime);
            if (addItem) {
                dateSpan = document.createElement("span");
                dateSpan.id = "date";
                dateSpan.innerText = dt;
                nodeItem.appendChild(dateSpan);
            }
            else {
                dateSpan = nodeItem.children[1];
                dateSpan.innerText = dt;
            }
            
            var subjectSpan = null;
            var s = mailItem.Subject;
            if (addItem) {
                subjectSpan = document.createElement("span");
                subjectSpan.id = "subject";
                subjectSpan.innerText = s;
                nodeItem.appendChild(subjectSpan);
            }
            else {
                subjectSpan = nodeItem.children[2];
                subjectSpan.innerText = s;
            }
          
            if (addItem) {
                elContainer.appendChild(nodeItem);
                nodeItem.onmouseout = getEventHandler("mailItemOut", nodeItem);
                nodeItem.onmouseover = getEventHandler("mailItemHover", nodeItem);
                nodeItem.onclick = getEventHandler("mailItemClick", nodeItem);
            }
            var sz = Math.round(mailItem.Size / 1000);
            nodeItem.title = "Received: " + dt + "\nFrom: " + sn + "\nSubject: " + s + "\nSize: " + sz + " KB";
            if (i >= maxEmails) { return true ; }
        }
        if (objFolderItems.Count > 0) {
           var nodeItems = elContainer.all.tags("div");
           if (objFolderItems.Count != nodeItems.length) {
                var nodeCount = nodeItems.length - 1;
                for (var i = nodeCount; i >= objFolderItems.Count; i--) {
                    elContainer.removeChild(nodeItems[i]);
                }
            }
        }
        else {
            var nodeItems = elContainer.all.tags("div");
            var nodeCount = nodeItems.length - 1;
            for (var i = nodeCount; i >= 0; i--) {
                elContainer.removeChild(nodeItems[i]);
            }
        }
        return true;
    }
    catch(err) {
        errorMessage = err.name + " - " + err.message;
        return false;
    }
}

function getNextMessage() {
    var nodeItems = elContainer.all.tags("div");
    var nodeCount = nodeItems.length - 1;
    for (var i = 0; i <= nodeCount; i++) {
        if (elSelectedMessage == nodeItems[i]) {
            var newIdx = i + 1;
            if (newIdx > nodeCount) { newIdx = nodeCount; }
            if (elSelectedMessage != null) { setElementStyle(elSelectedMessage, "NORMAL"); }
            elSelectedMessage = nodeItems[newIdx];
            elSelectedMessage.className = "";
            elSelectedMessage.scrollIntoView(false);
            setElementStyle(elSelectedMessage, "SELECTED");
            objSelectedMessage = objFolderItems(elSelectedMessage.messageIdx);
            if (objSelectedMessage.UnRead) { unreadCount--; }
            objSelectedMessage.UnRead = false;
            if (unreadCount < 0) { unreadCount = 0; }
            elUnreadCount.innerText = unreadCount;
            return objSelectedMessage;
        }
    }
    return objSelectedMessage;
}

function getPrevMessage() {
    var nodeItems = elContainer.all.tags("div");
    var nodeCount = nodeItems.length - 1;
    for (var i = 0; i <= nodeCount; i++) {
        if (elSelectedMessage == nodeItems[i]) {
            var newIdx = i - 1;
            if (newIdx < 0) { newIdx = 0; }
            if (elSelectedMessage != null) { setElementStyle(elSelectedMessage, "NORMAL"); }
            elSelectedMessage = nodeItems[newIdx];
            elSelectedMessage.className = "";
            elSelectedMessage.scrollIntoView(false);
            setElementStyle(elSelectedMessage, "SELECTED");
            objSelectedMessage = objFolderItems(elSelectedMessage.messageIdx);
            if (objSelectedMessage.UnRead) { unreadCount--; }
            objSelectedMessage.UnRead = false;
            if (unreadCount < 0) { unreadCount = 0; }
            elUnreadCount.innerText = unreadCount;
           return objSelectedMessage;
        }
    }
    return objSelectedMessage;
}

function formatDate(dt) {
    var newDate = new Date(dt);
    var monthEnum = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
    var dayEnum = ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"];
    var sDay = dayEnum[newDate.getDay()];
    var sMonth = monthEnum[newDate.getMonth()];
    var iDay = (newDate.getDate() < 10 ? "0" + newDate.getDate() : newDate.getDate());
    var iYear = newDate.getFullYear();
    var iHour = (newDate.getHours() <= 12 ? newDate.getHours() : newDate.getHours() - 12);
    var iMin = (newDate.getMinutes() < 10 ? "0" + newDate.getMinutes() : newDate.getMinutes());
    var iSec = (newDate.getSeconds() < 10 ? "0" + newDate.getSeconds() : newDate.getSeconds());
    var sAmPm = (newDate.getHours() <= 12 ? "AM" : "PM");
    return sDay + " " + sMonth + " " + iDay + ", " + iYear + " " + (iHour < 10 ? "0" + iHour : iHour) + ":" + iMin + ":" + iSec + " " + sAmPm;
}

function getEventHandler(method, parm1, parm2) {
    return function(){ window[method](parm1, parm2); };
}

function setElementStyle(el, style) {
    switch(style) {
        case "NORMAL":
            el.style.backgroundColor = "#ffffff";
            el.children[0].style.color = "#000000";
            el.children[1].style.color = "#000000";
            el.children[2].style.color = "#808080";
            break    
        case "HOVER":
            el.style.backgroundColor = "#c0ddfc";
            if (elSelectedMessage == el) {
                el.children[0].style.color = "#000000";
                el.children[1].style.color = "#000000";
                el.children[2].style.color = "#808080";
            }
            break
        case "SELECTED":
            el.style.backgroundColor = "#3399ff";
            el.children[0].style.color = "#ffffff";
            el.children[1].style.color = "#ffffff";
            el.children[2].style.color = "#ffffff";
            break
        default:
            el.style.backgroundColor = "#ffffff";
            el.children[0].style.color = "#000000";
            el.children[1].style.color = "#000000";
            el.children[2].style.color = "#808080";
    }
}

function scrollContainerElement() {
	clearTimeout(objScrollTimer) ;
	try {
		if (scrollDirection == "") {
			return ;
		}
		else if (scrollDirection == "UP") {
			var newScrollTop = elContainer.scrollTop - 3 ;
		}
		else {
			var newScrollTop = elContainer.scrollTop + 3 ;
		}
		elContainer.scrollTop = newScrollTop ;
	}
    catch(err) {
        errorMessage = err.name + " - " + err.message;
	}
	objScrollTimer = setTimeout(scrollContainerElement, 15) ;
}

// public functions
function ShowErrorMessage() {
    var oShell = new ActiveXObject("WScript.Shell");
    oShell.Popup(errorMessage, 0, "SideBar Outlook", 48);
    errorMessage = "";
}

function ScrollCancel() {
	clearTimeout(objScrollTimer) ;
	scrollDirection = "" ;
    objRefreshTimer = setTimeout("refreshFolder()", refreshInterval);
}

function ScrollUp() {
    clearTimeout(objRefreshTimer);
	scrollDirection = "UP" ;
	scrollContainerElement() ;
}

function ScrollDown() {
    clearTimeout(objRefreshTimer);
	scrollDirection = "DOWN" ;
	scrollContainerElement() ;
}

function ShowFlyout() {
    try {
        System.Gadget.Flyout.show = true;   
    }
    catch(err) {
        errorMessage = err.name + " - " + err.message;
    }
}

function HideFlyout() {
    try {
        System.Gadget.Flyout.show = false;   
    }
    catch(err) {
        errorMessage = err.name + " - " + err.message;
    }
}
 
function GetSelectedMessage() {
    try {
        return objSelectedMessage;
    }
    catch(err) {
        errorMessage = err.name + " - " + err.message;
    }
}
          
function EmailNew() {
    HideFlyout();
    try {
        objOutlook.CreateItem(0).Display();
    }
    catch(err) {
        errorMessage = err.name + " - " + err.message;
    }
}
           
function EmailDelete() {
    HideFlyout();
    try {
        objSelectedMessage.Delete();
    }
    catch(err) {
        errorMessage = err.name + " - " + err.message;
    }
}

function EmailReply() {
    HideFlyout();
    try {
        objSelectedMessage.Reply().Display();
    }
    catch(err) {
        errorMessage = err.name + " - " + err.message;
    }
}

function EmailReplyAll() {
    HideFlyout();
    try {
        objSelectedMessage.ReplyAll().Display();
    }
    catch(err) {
        errorMessage = err.name + " - " + err.message;
    }
}

function EmailForward() {
    HideFlyout();
    try {
        objSelectedMessage.Forward().Display();
    }
    catch(err) {
        errorMessage = err.name + " - " + err.message;
    }
}

function EmailJunk() {
    HideFlyout();
    try {
        var objJunkFldr = objMapi.GetDefaultFolder(olFolderJunk);
        if (objJunkFldr != null) {
            objSelectedMessage.Move(objJunkFldr);
        }
    }
    catch(err) {
        errorMessage = err.name + " - " + err.message;
    }
}

function EmailPrint() {
    HideFlyout();
    try {
        objSelectedMessage.PrintOut();
    }
    catch(err) {
        errorMessage = err.name + " - " + err.message;
    }
}

function EmailMove() {
    HideFlyout();
    try {
        var objDestFldr = pickOutlookFolder();
        if (objDestFldr != null) {
            objSelectedMessage.Move(objDestFldr);
        }
    }
    catch(err) {
        errorMessage = err.name + " - " + err.message;
    }
}

function EmailNext() {
    try {
        return getNextMessage();
    }
    catch(err) {
        errorMessage = err.name + " - " + err.message;
    }
}

function EmailPrev() {
    try {
        return getPrevMessage();
    }
    catch(err) {
        errorMessage = err.name + " - " + err.message;
    }
}

// events
function settingsClosed() {
    maxEmails = parseInt(System.Gadget.Settings.read("maxEmails"));
    if(isNaN(maxEmails)) { maxEmails = 10; }
    refreshInterval = parseInt(System.Gadget.Settings.read("refreshInterval"));
    if(isNaN(refreshInterval)) { refreshInterval = 3000; }
    syncInterval = parseInt(System.Gadget.Settings.read("syncInterval"));
    if(isNaN(syncInterval)) { syncInterval = 300000; }
}

function flyoutShow() {
    clearTimeout(objRefreshTimer);
}

function flyoutHide() {
     if (elSelectedMessage != null) {
        setElementStyle(elSelectedMessage, "NORMAL");
        elSelectedMessage = null;
    }
    objRefreshTimer = setTimeout("refreshFolder()", refreshInterval);
}

function dockGadget() {   
	document.body.style.width = '140px';
	document.body.style.height = '200px';
	elContainer.className = 'docked';
	elUnreadCount.className = 'docked';
	document.getElementById("scrollUp").className = 'docked';
	document.getElementById("scrollDown").className = 'docked';
    elBackground.src = "url(images/sboDocked.png)";
    elBackground.style.width = '140px';
	elBackground.style.height = '200px';
}

function undockGadget() {
 	document.body.style.width = '292px';
	document.body.style.height = '302px';
	elContainer.className = 'undocked';
	elUnreadCount.className = 'undocked';
	document.getElementById("scrollUp").className = 'undocked';
	document.getElementById("scrollDown").className = 'undocked';
    elBackground.src = "url(images/sboUndocked.png)";
    elBackground.style.width = '292px';
	elBackground.style.height = '302px';
}

function refreshFolder() {
    refreshOutlookFolderItems();
}

function mailItemOut(el) {
    if (elSelectedMessage == el) {
        setElementStyle(el, "SELECTED");
    }
    else {
        setElementStyle(el, "NORMAL");
    }
}

function mailItemHover(el) {
    setElementStyle(el, "HOVER");
}

function mailItemClick(el) {
    if (elSelectedMessage != null) {
        setElementStyle(elSelectedMessage, "NORMAL");
    }
    elSelectedMessage = el;
    elSelectedMessage.className = "";
    setElementStyle(elSelectedMessage, "SELECTED");
    objSelectedMessage = objFolderItems(elSelectedMessage.messageIdx);
    if (objSelectedMessage.UnRead) { unreadCount--; }
    objSelectedMessage.UnRead = false;
    if (unreadCount < 0) { unreadCount = 0; }
    elUnreadCount.innerText = unreadCount;
    ShowFlyout();
}
