///////////////////////////////////////////////////
//
//  JavaScript library to build Tab interface on The fly
//
///////////////////////////////////////////////////


function TabBuilder() {
    var tabAlign = "LEFT"; //LEFT, CENTER, RIGHT
    var tabClassOn = "tabOn";
    var tabClassOff = "tabOff";

    var arrControlsNames = new Array();
    var arrControlValues = new Array();
    var arrSkinColors = null;

    this.SetTabAlign = SetTabAlign;
    this.GetTabAlign = GetTabAlign;
    this.GetTabClassOn = GetTabClassOn;
    this.SetTabClassOn = SetTabClassOn;
    this.SetTabClassOff = SetTabClassOff;
    this.GetTabClassOff = GetTabClassOff;
    this.GetTabHtml = GetTabHtml;
    this.SetSelected = SetSelected;
    this.AddControl = AddControl;
    this.GetSelected = GetSelected;
    this.HaveControl = HaveControl;
    this.BuildContentHtml = BuildContentHtml;
    this.BuildButtonHtml = BuildButtonHtml;

    this.SetSkinColors = SetSkinColors;
    this.GetSkinColors = GetSkinColors;

    function GetSkinColors() {
        return arrSkinColors;
    }

    function SetSkinColors(ArraySkinColors) {
        arrSkinColors = ArraySkinColors;
    }

    function SetTabClassOn(styleclass) {
        tabClassOn = styleclass;
    }

    function SetTabClassOff(styleclass) {
        tabClassOff = styleclass;
    }

    function GetTabClassOn() {
        return tabClassOn;
    }
    function GetTabClassOff() {
        return tabClassOff;
    }

    function GetTabAlign() {
        return tabAlign;
    }

    function SetTabAlign(align) {
        tabAlign = align;
    }

    function HaveControl(controlid) {
        for (var i = 0; i < arrControlsNames.length; ++i) {
            if (arrControlsNames[i] == controlid) {
                return true;
            }
        }
        return false;
    }

    function AddControl(controlid, idxSelected, arrButtons, arrContent) {
        //System.Debug.outputString("TabBuilder.AddControl("+controlid+", "+idxSelected+")");
        for (var i = 0; i < arrControlsNames.length; ++i) {
            if (arrControlsNames[i] == controlid) {
                arrControlValues[i] = new Array(arrButtons, arrContent, idxSelected);
                return;
            }
        }
        var idx = arrControlsNames.length;
        arrControlsNames[idx] = controlid;
        arrControlValues[idx] = new Array(arrButtons, arrContent, idxSelected);
    }

    function SetSelected(controlid, idxSelected) {
        var controlValues = GetControlValues(controlid);
        controlValues[2] = idxSelected;
    }

    function GetSelected(controlid) {
        var controlValues = GetControlValues(controlid);
        if (null == controlValues) return 0;
        return controlValues[2];
    }

    function GetControlValues(controlid) {

        for (var i = 0; i < arrControlsNames.length; ++i) {
            if (arrControlsNames[i] == controlid) {
                return arrControlValues[i];
            }
        }
        return null;
    }

    function GetButtonHtml(controlid, controlValues) {
        var output = "";
        var arrButons = controlValues[0];
        var idxSelected = controlValues[2];
        for (var i = 0; i < arrButons.length; ++i) {
            var buttonClass = GetTabClassOff();
            var buttonID = controlid + "_button" + i;
            if (i == idxSelected) {
                buttonClass = GetTabClassOn();
            }
            //output += "<input type='button' id = "+buttonID+" class= '"+buttonClass+"' value='"+arrButons[i]+"'" ;
            output += "<input type='button' id = " + buttonID + " class= '" + buttonClass + "' value='" + arrButons[i] + "'";
            output += " style='color:" + getTabTextColor(i == idxSelected) + "; background-color:" + getTabColor(i == idxSelected) + "; border-top: " + getButtonHiliteColor(i == idxSelected) + " 1PX  solid;'";
            output += " onclick='onTabClick(\"" + controlid + "\", " + i + ");' /> ";
            //System.Debug.outputString("GetButtonHtml: "+ output);
        }

        return output;
    }
    function getButtonHiliteColor(bSelected) {
        if (bSelected) {
            return 'yellow';
        }
        return 'transparent';
    }
    function getTabTextColor(bSelected) {
        var color = getTabTextColor_(bSelected);
        //System.Debug.outputString("getTabTextColor("+bSelected+")->"+color);
        return color;
    }
    function getTabColor(bSelected) {
        var color = getTabColor_(bSelected);
        //System.Debug.outputString("getTabColor("+bSelected+")->"+color);
        return color;
    }

    function getTabTextColor_(bSelected) {
        if (bSelected) {
            return "#" + arrSkinColors[12];
        } else {
            return "#" + arrSkinColors[9];
        }
    }

    function getTabColor_(bSelected) {
        if (bSelected) {
            return "#" + arrSkinColors[13];
        } else {
            return "#" + arrSkinColors[10];
        }
    }

    function BuildButtonHtml(controlid) {
        var output = "";

        var controlValues = GetControlValues(controlid);
        if (null == controlValues) {
            //System.Debug.outputString("TabBuilder.GetTabHtml cannot get values for "+ controlid);
            return output;
        }

        return GetButtonHtml(controlid, controlValues);
    }

    function GetContentHtml(controlid, controlValues) {
        var idxSelected = controlValues[2];
        var arrContent = controlValues[1];
        return arrContent[idxSelected];
    }

    function BuildContentHtml(controlid) {
        var output = "";
        var controlValues = GetControlValues(controlid);
        if (null == controlValues) {
            //System.Debug.outputString("TabBuilder.GetTabHtml cannot get values for "+ controlid);
            return output;
        }
        return GetContentHtml(controlid, controlValues);
    }

    function GetTabHtml(controlid, verticalButtons, someComments) {
        var output = "";

        var comments = (null == someComments || undefined == someComments) ? "" : someComments;

        var controlValues = GetControlValues(controlid);
        if (null == controlValues) {
            //System.Debug.outputString("TabBuilder.GetTabHtml cannot get values for "+ controlid);
            return output;
        }
        var buttonHtml = GetButtonHtml(controlid, controlValues, comments);

        var contentHtml = GetContentHtml(controlid, controlValues);

        //output += "<div id='divTabButtons_"+controlid+">"+buttonHtml+"</div>";
        //output += "<div id='divTabContent_"+controlid+">"+contentHtml+"</div>";
        if (verticalButtons) {
            output += "<table style='table-layout:auto;'><tr><td valign='top' class='tabButtonRowV'>" + buttonHtml + "</td><td class='tabContentRowV'>" + contentHtml + "</td></tr></table>";
        } else {
            output += "<table style='table-layout:auto;'><tr><td class='tabButtonRow'>" + buttonHtml + comments + "</td></tr><tr align='center'><td class='tabContentRow'>" + contentHtml + "</td><td></td></tr></table>";
        }
        //output += buttonHtml + contentHtml;
        return output;
    }

}
