////////////////////////////////////////////////////////////////////////////////
//
// Xirrus Wi-Fi monitor javascript library 
//
////////////////////////////////////////////////////////////////////////////////
var OneSecond = 1000;  // Represents one second.
var frequency = 1;  // Feed refresh rate in minutes
var DefaultSkinIndex = 2;
var timeout;
var sweepTimeout;

var adapterIndex = 0; //default adapter to display 
var displaytypeIndex = 0; //defaults are percentage display
// Instance of the GadgetBuilder to load/unload .NET assemblies.  See GadgetInterop.js
var builder = new GadgetBuilder();

builder.Initialize();

var baseImagePercent = "Xirrus-VistaGadget_Percent_Boxes.png";
var baseImageText = "Xirrus-VistaGadget_dBm_Boxes.png";
var baseImagePercentDocked = "Xirrus-VistaGadget_Percent_noBoxes.png";
var baseImageTextDocked = "Xirrus-VistaGadget_dBm_noBoxes.png";

var arrBaseImageUndock = new Array(baseImagePercent, baseImageText);
//var arrBaseImageDock = new Array(baseImagePercent, baseImageText);
var arrBaseImageDock = new Array(baseImagePercentDocked, baseImageTextDocked);

//temporary keep same for docked, comment it later 


var baseImage = arrBaseImageUndock;


//colors in row are folowing : 
//0: text -> normal text elem
//1: param text -> values 
//2: table header bk
//3: table header text
//4: table alternate row bk
//5: table alternate row text
//6: table row bk
//7: connected row bk
//8: connected row text
//9: tab text
//10: tab bk
//11: tab shadow
//12: selected tab text
//13: selected tab bk
//14: selected tab shadow
//15: mouse over header color
//16: table row text
//17: button text
//18: button bk 



var arrSkinColors = new Array(
//            0          1        2           3       4          5         6         7        8         9         10       11         12        13     14        15     16          17         18
 new Array("000000", "0000ff", "003445", "FFFFFF", "00536D", "FFFFFF", "00536d", "FFA500", "000000", "003445", "DDDDDD", "909090", "ffa500", "003445", "ffa500", "FFA500", "000000", "FFFFFF", "005e7c"),  //zero -> default colors
 new Array("DDDDDD", "ffffff", "000000", "dddddd", "ffa500", "FFFFFF", "404040", "FFA500", "000000", "000000", "DDDDDD", "000000", "dddddd", "404040", "ffa500", "ffa500", "000000", "000000", "979797"),  //Skin 1 Black
 new Array("FFFFFF", "ffa500", "000000", "FFFFFF", "1862a1", "93c7f3", "273f68", "FFA500", "000000", "000000", "DDDDDD", "000000", "d0d0d0", "273f68", "ffa500", "ffa500", "000000", "000000", "979797"),   //Skin 2 Dark Blue
 new Array("000000", "663c1f", "000000", "FFFFFF", "f08346", "FFFFFF", "563118", "FFA500", "000000", "000000", "AAAAAA", "000000", "FFFFFF", "563118", "ffa500", "ffa500", "000000", "FFFFFF", "492c0a"),  //skin 3 Brown
 new Array("000000", "685213", "312b07", "FFFFFF", "efac54", "ffa500", "685213", "FFA500", "000000", "000000", "DDDDDD", "000000", "f6E097", "312b07", "ffa500", "ffa500", "000000", "FFFFFF", "4d3f1b"),  //skin 4 Gold
 new Array("000000", "666666", "666666", "e8e8e8", "818181", "FFFFFF", "4c4c4c", "FFA500", "000000", "000000", "AAAAAA", "000000", "999999", "2a2a2a", "666666", "ffa500", "000000", "FFFFFF", "060606"),  //skin 5 Gray 
 new Array("000000", "4C7B31", "006400", "FFFFFF", "449e4d", "b4e836", "255512", "fFA500", "000000", "000000", "DDDDDD", "000000", "96C58C", "4C7B31", "ffa500", "FFA500", "000000", "FFFFFF", "146d2d"),  //skin 6 Green
 new Array("1B1464", "d97319", "4c4b6e", "FFFFFF", "9f48ae", "ffa500", "333333", "FFA500", "000000", "000000", "AAAAAA", "000000", "A4A8C9", "35325d", "ffa500", "ffa500", "000000", "FFFFFF", "603e94"),  //skin 7 Purple
 new Array("000000", "8C161A", "8c161a", "FFFFFF", "7d4c4d", "FFFFFF", "666666", "FFA500", "000000", "000000", "DDDDDD", "000000", "FFFFFF", "882023", "666666", "ffa500", "000000", "FFFFFF", "9a021b")  //skin 8 Red

 );

//-> history background color
// 1-> history grid line color 
// 2-> history value line color
// 3-> history value highlite color 
var arrSkinHistoryColors = new Array(
//                0         1          2        3
    new Array("000000", "0000ff", "ffa500", "FFFFFF"),  //Blue default
    new Array("979797", "010101", "ffa500", "FFFFFF"),  //Black
    new Array("00536D", "ffffff", "ffa500", "FFFFFF"),   //Dark Blue
    new Array("000000", "7a4825", "ffa500", "FFFFFF"),  //Brown
    new Array("000000", "baa002", "ffa500", "FFFFFF"),  //Gold
    new Array("010101", "c0c0c0", "ffa500", "FFFFFF"),  //Gray
    new Array("000000", "008000", "ffa500", "FFFFFF"),  //Green
    new Array("130e48", "FFFFFF", "ffa500", "FFFFFF"),  //Purple
    new Array("000000", "ff0000", "ffa500", "FFFFFF")  //Red
);

function changeBaseImageArray(docked) {
    if (docked) {
        baseImage = arrBaseImageDock;
    } else {
        baseImage = arrBaseImageUndock;
    }
}

function changeGraphicToBoxes(enable) {
    if (enable) {
        baseImage = arrBaseImageUndock;
    } else {
        baseImage = arrBaseImageDock;
    }
}

// .NET instance of the wifi monitor object.
var wrapi;
var hasWrapi = false;

var xirrusurl = "http://www.xirrus.com";

////////////////////////////////////////////////////////////////////////////////
//
// Set up the gadget and subscribe to events
//
////////////////////////////////////////////////////////////////////////////////
function LoadWifiMonitor() {
    System.Gadget.Flyout.file = "Flyout.html";
    System.Gadget.Flyout.onShow = OnShowFlyout;
    System.Gadget.settingsUI = "settings.html";
    System.Gadget.onSettingsClosed = SettingsClosed;
    System.Gadget.onShowSettings = ShowSettings;
    System.Gadget.onUndock = CheckDock;
    System.Gadget.onDock = CheckDock;

    // Resize based on dock state
    CheckDock();

    self.focus;
    document.body.focus();

}




var instance_guid;



function getBaseImageName() {
    if (0 == displaytypeIndex) {
        return baseImage[0]; //percent
    }
    return baseImage[1]; //dbm units
}


function DoUnload() {
    //System.Debug.outputString("DoUnload");
    //System.Debug.outputString(" deleteding "+instance_guid);
    wrapi.ClearImage(System.Gadget.path + "\\images\\", instance_guid);
    //System.Debug.outputString(" deleted "+image_guid);
    builder.UnloadType(wrapi);

}

function UnLoadWrapi() {


    //System.Debug.outputString("UnLoadWrapi()");
    try {

        if (hasWrapi == true) {
            hasWrapi = false;
            var background = "images/Xirrus-Vista-Gadget.png";
            backgroundImage.src = background;

            //timeout = setTimeout('DoUnload();', 1);
            //System.Debug.outputString("UnLoadWrapi() hasWrapi"+hasWrapi);
            //System.Debug.outputString(" deleteding "+instance_guid);
            wrapi.ClearImage(System.Gadget.path + "\\images\\", instance_guid);
            //System.Debug.outputString(" deleted "+image_guid);
            //builder.UnloadType(wrapi);

        } else {
            //System.Debug.outputString("UnLoadWrapi() hasWrapi = false");
        }
    } catch (e) {
        //System.Debug.outputString("UnLoadWrapi() exception: "+e);
    }

}

////////////////////////////////////////////////////////////////////////////////
//
// Call the method of the .NET object to read the wireless settings
//
////////////////////////////////////////////////////////////////////////////////

function LoadWrapi() {
    displaytypeIndex = System.Gadget.Settings.read("displaytypeIndex");
    if (null == displaytypeIndex) {
        displaytypeIndex = 0;
    }

    if (hasWrapi == false) {
        //System.Debug.outputString("LoadWrapi");
        builder.AddConstructorParam("unu");
        if ("x64" == System.Machine.processorArchitecture) {
            wrapi = builder.LoadType(System.Gadget.path,
				 "\\bin\\x64\\sharpwrapi_x64.dll", "sharpwrapi.Wrapi");
        } else {
            wrapi = builder.LoadType(System.Gadget.path,
				 "\\bin\\x86\\sharpwrapi_Win32.dll", "sharpwrapi.Wrapi");
        }
        instance_guid = wrapi.CreateInstanceID();
        //System.Debug.outputString("wrapi instanceid= "+instance_guid);
        hasWrapi = true;
        //System.Debug.outputString("LoadWrapi "+ wrapi+" done");
    }
}


function OnClick(event) {
    var x = event.clientX;
    var y = event.clientY;

    var result = wrapi.OnClick(x, y);
    //System.Debug.outputString("JS: wrapi.OnClick ("+x+","+y+") result "+result);

    if (result != "") {
        if ('arapterclick' == result
       || 'radarclick' == result) {
            ShowHideFlyout();
            event.returnValue = false; //cancel default action
            return;
        }
        else if ('exitlocate' == result) {
            var adapterIndex = System.Gadget.Settings.read("adapterIndex");
            var adapter = wrapi.GetAdapter(adapterIndex);

            adapter.ExitLocateMode();

            if (System.Gadget.Flyout.show) {
                System.Gadget.Flyout.document.refreshflyout();
            }
            //System.Debug.outputString("adapter.ExitLocateMode();");
            ShowTheWireless(false);
            //ShowWireless();
            event.returnValue = false; //cancel default action                        
        }

    } else {
        //if( isOnPoltysLogo(x, y) ){
        //  open(poltysurl, "", "", false);
        //  event.returnValue = false; //cancel default action
        //  return ;
        //}
        if (isOnXirrusLogo(x, y)) {
            open(xirrusurl, "", "", false);
            event.returnValue = false; //cancel default action
            return;
        }
    }
    event.returnValue = true; //do default action
    return;

}


function isOnXirrusLogo(x, y) {
    if (!System.Gadget.docked) {
        if (150 < x && x < 244
            && 6 < y && y < 26) {
            return true;
        }
    } else {
        if (89 < x && x < 132
            && 4 < y && y < 20) {
            return true;
        }


    }
    return false;
}
/*
function isOnPoltysLogo(x, y)
{
if(!System.Gadget.docked){
if( 6 < x && x < 54
&& 238 < y && y< 251)
{
            
return true;
}
}else
{
if( 3 < x && x < 28
&& 127 < y && y< 132)
{
            
return true;
}
}
return false;

}
*/
function OnMouseMove(event) {

    var x = event.clientX;
    var y = event.clientY;
    //System.Debug.outputString("OnMouseMove( "+x+","+y+")");
    if (null == wrapi) {
        return;
    }

    var status = wrapi.OnMouseMove(x, y);
    var bk = document.getElementById('backgroundImage');
    bk.style.cursor = 'arrow';
    if (0 != status) {
        /*
        try{
        
        var adapterCrt = System.Gadget.Settings.read("adapterIndex");
        if(""==adapterCrt)
        {
        adapterCrt =0;
        }
        var adapter = wrapi.GetAdapter(adapterCrt);
        
        var skinindex = 0;    
        skinindex =  System.Gadget.Settings.read("skinIndex");
        if(null == skinindex || skinindex==undefined || (0 == skinindex.toString().length)){
        skinindex=0;
        }	    
        var skin_name = "skins\\Skin "+ skinindex+"\\";

    	//System.Debug.outputString("Get Image skin_nanme="+skin_name);
    	    
        try{
        var colors = arrSkinColors[skinindex];
        adapter.SkinTextColor= colors[0];
        adapter.SkinHighliteColor = colors[1];
        adapter.SetButtonColors(colors[17], colors[18]);
        //System.Debug.outputString("OnMouse: SkinTextColor="+colors[0]+" SkinHighliteColor="+colors[1]);
        }
        catch(e)
        {
        }
    	    

	        var imageName = adapter.GetImageName(System.Gadget.path+"\\images\\" + skin_name, 
        getBaseImageName(),  
        System.Network.Wireless.address, 
        instance_guid);

	        backgroundImage.src = imageName;
        }catch(exception)
        {
        System.Debug.outputString("OnMouseMove exception:" + exception.ToString());
        }
        */
        //System.Debug.outputString("wrapi.OnMouseOver "+x+","+y);
        bk.style.cursor = 'hand';
        event.returnValue = true;
        return;
    }


    if (isOnXirrusLogo(x, y))// || isOnPoltysLogo(x, y))
    {
        bk.style.cursor = 'hand';
        event.returnValue = false;
    }
    else {

        event.returnValue = true;
    }

}


function LoadLastSettings(wrapi) {
    if (null == wrapi) return;

    //System.Debug.outputString("test : " + wrapi.GetProperty("test", "0") ); 

    var ai;
    var skinIndex;
    var enableRotation;
    var displayUnits;
    var rssiMethod;

    ai = wrapi.GetProperty("adapterIndex", "0");
    skinIndex = wrapi.GetProperty("skinIndex", "" + DefaultSkinIndex);
    enableRotation = wrapi.GetProperty("enableRotation", "0");
    rssiMethod = wrapi.GetProperty("rssiMethod", "0");
    displayUnits = wrapi.GetProperty("displayUnits", "0");
    var enableLocateSound = wrapi.GetProperty("enableLocateSound", "1");
    var pollTimeout = wrapi.GetProperty("pollTimeout", "2");

    /*
    System.Debug.outputString("LoadLastSettings ai="+ai);
    System.Debug.outputString("LoadLastSettings skinIndex="+skinIndex);
    System.Debug.outputString("LoadLastSettings enableRotation="+enableRotation);
    System.Debug.outputString("LoadLastSettings rssiMethod="+rssiMethod);
    System.Debug.outputString("LoadLastSettings displayUnits="+displayUnits);
    */

    System.Gadget.Settings.write("adapterIndex", ai);
    System.Gadget.Settings.write("displaytypeIndex", displayUnits);
    System.Gadget.Settings.write("rssimethodIndex", rssiMethod);
    System.Gadget.Settings.write("skinIndex", skinIndex);
    System.Gadget.Settings.write("enableRotation", enableRotation);
    System.Gadget.Settings.write("enableLocateSound", enableLocateSound);
    System.Gadget.Settings.write("pollTimeout", pollTimeout);

}

function ShowTheWireless(benable) {
    //System.Debug.outputString("ShowTheWireless("+ benable+")");
    changeBaseImageArray(benable);
    ShowWireless();

}

function ShowWireless() {
    // Exit if could no load wrapi
    var setupText = document.getElementById('setupText');
    //System.Debug.outputString("gadget update");

    if (false == hasWrapi) {
        setupText.innerText = "Wireles not loaded";
        //System.Debug.outputString("ShowWireless hasWrapi==false");
        return;
    }
    // Call this method every N seconds


    var successLoad = '';
    var count = 0;
    if (null == wrapi) {
        setupText.innerText = "Can't load Gadget";
        return;
    }

    count = wrapi.GetNumWireless();

    var noadapter = true;
    if (count > 0) {
        noadapter = false;
        var oldindex = adapterIndex;
        adapterIndex = System.Gadget.Settings.read("adapterIndex");

        var adapter;
        try {
            adapter = wrapi.GetAdapterS("" + adapterIndex);
        } catch (excpt) {
            //System.Debug.outputString("ShowWireless exception resetting adapterindex to zero from"+adapterIndex);
            //System.Debug.outputString(excpt);
            adapterIndex = 0;
            LoadLastSettings(wrapi);
            adapter = wrapi.GetAdapterS("" + adapterIndex);


        }

        if (null == adapterIndex || adapterIndex == undefined || (0 == adapterIndex.toString().length)) {

            adapterIndex = 0;
            LoadLastSettings(wrapi);
            adapter = wrapi.GetAdapterS("" + adapterIndex);

        }
        //System.Debug.outputString("ShowWireless: ----- adapterIndex="+adapterIndex);

        try {
            //succesload = adapter.SSID + " "+adapter.RSSI+" dBm";

            adapter.SetDisplayType(1 == displaytypeIndex);
            var rssimethodIndex = System.Gadget.Settings.read("rssimethodIndex");
            adapter.SetRssiMethod(1 == rssimethodIndex);

            var skinindex = System.Gadget.Settings.read("skinIndex");
            if (null == skinindex || skinindex == undefined || (0 == skinindex.toString().length)) {
                skinindex = DefaultSkinIndex;
            }

            var skin_name = "skins\\Skin " + skinindex + "\\";

            //System.Debug.outputString("ShowWireless: Get Image skin_nanme="+skin_name);

            try {
                var colors = arrSkinColors[skinindex];
                var historyColors = arrSkinHistoryColors[skinindex];
                adapter.SkinTextColor = colors[0];
                adapter.SkinHighliteColor = colors[1];
                adapter.SetButtonColors(colors[17], colors[18]);
                adapter.SetHistoryColors(historyColors[0], historyColors[1], historyColors[2], historyColors[3]);
                //System.Debug.outputString("ShowWireless: SkinTextColor="+colors[0]+" SkinHighliteColor="+colors[1]);
            }
            catch (e) {
            }

            var radarBeam = document.getElementById("radarBeam");
            if (!System.Gadget.docked) {
                radarBeam.src = System.Gadget.path + "\\images\\" + skin_name + "\\radar_beam.png";
            } else {
                radarBeam.src = System.Gadget.path + "\\images\\" + skin_name + "\\radar_beam_dock.png";
            }
            //System.Debug.outputString("radarBeam.src = "+radarBeam.src);

            /*if(!adapter.IsDisabled())
            {
            */
            var initialImage = getBaseImageName();
            //System.Debug.outputString("initialImage = '"+initialImage+"'");
            var imageName = adapter.GetImageName(System.Gadget.path + "\\images\\" + skin_name,
	                        initialImage,
					         System.Network.Wireless.address,
					         instance_guid);

            //System.Debug.outputString("imageName = "+ imageName);

            try {
                if (null != adapter.LastImage) {

                    adapter.LastImageName = imageName;

                }
            } catch (exceptione) { }
            /*	  
            var imageName = adapter.GetImageName(System.Gadget.path+"\\images\\", getBaseImageName(),  
            System.Network.Wireless.address, instance_guid);
            */


            //System.Debug.outputString("got image name '"+imageName+"'");
            backgroundImage.src = imageName;

            pollTimeout = System.Gadget.Settings.read("pollTimeout");
            var IntervalMs = GetPoolTimeout(pollTimeout);

            if (adapter.PoolIntervalMs != IntervalMs) {
                adapter.PoolIntervalMs = IntervalMs;
                wrapi.CheckIntervalMs = IntervalMs;


            }
            timeout = setTimeout('ShowWireless();', IntervalMs + 100);

            /*
            }else{
            successLoad = "Adapter Disabled";
            var imageName = adapter.LastImageName;
            if("" == imageName){
            imageName = System.Gadget.path+"\\images\\" + skin_name+ "\\" + getBaseImageName();
            }
            System.Debug.outputString("Adapter Disabled: '"+imageName+"'") ;
            backgroundImage.src = imageName;
            }*/

        } catch (excpt) {
            successLoad = "Cant Find Wi-Fi \r\nAdapter " + adapterIndex + ".\r\nPlease choose\r\na valid adapter";
            //System.Debug.outputString("ShowWireless exception for adapter id="+adapterIndex);
            //System.Debug.outputString(excpt);

            var imageName = System.Gadget.path + "\\images\\" + skin_name + "\\" + getBaseImageName();

            try {
                imageName = adapter.LastImageName;




                if ("" == imageName) {
                    imageName = System.Gadget.path + "\\images\\" + skin_name + "\\" + getBaseImageName();
                }
            } catch (exe) {
                imageName = System.Gadget.path + "\\images\\" + getBaseImageName();

            }
            //System.Debug.outputString("Adapter Disabled: '"+imageName+"'") ;
            backgroundImage.src = imageName;

        }
    }

    if (true == noadapter) {
        successLoad = "Cant Find \r\nWi-Fi Adapter";
    }


    setupText.innerText = successLoad;
    //SetLinkClass();


}

function GetPoolTimeout(poll_timeout) {
    if (null == poll_timeout) return 10000;
    switch (poll_timeout) {
        case 0: return 1000;
        case 1: return 2000;
        case 2: return 3000;
        case 3: return 4000;
        case 4: return 5000;
        case 5: return 10000;
        case 6: return 30000;
    }
    return 10000;
}


////////////////////////////////////////////////////////////////////////////////
//
// Shows or hides the flyout
//
////////////////////////////////////////////////////////////////////////////////
function ShowHideFlyout() {
    System.Gadget.Flyout.show = !System.Gadget.Flyout.show;
}


function updateFlyoutBackground() {

    var skinindex = System.Gadget.Settings.read("skinIndex");
    if (null == skinindex || skinindex == undefined || (0 == skinindex.toString().length)) {
        skinindex = DefaultSkinIndex;
    }

    var skin_name = "skins\\Skin " + skinindex + "\\";
    var img_name = System.Gadget.path + "\\images\\" + skin_name + "tiled_bg.png";
    var container = System.Gadget.Flyout.document.getElementById('container');
    container.style.backgroundImage = "url(" + img_name + ")";
}

function OnShowFlyout() {

    //System.Debug.outputString("setting wrapi on flyour");
    var theDocument = System.Gadget.Flyout.document;
    theDocument.SetWrapi(wrapi);
    updateFlyoutBackground();
    var fbuilder = System.Gadget.Flyout.document.GetFlyoutBuilder();
    fbuilder.SetWrapi(wrapi);

    var skinindex = System.Gadget.Settings.read("skinIndex");
    if (null == skinindex || skinindex == undefined || (0 == skinindex.toString().length)) {
        skinindex = DefaultSkinIndex;
    }
    var arrColors = arrSkinColors[skinindex];
    fbuilder.SetSkinColors(arrColors);

    //make default sort by RSSI for avaiillable networks table
    //var tablename = "AvaillableNetworksTable"+adapterIndex;
    //fbuilder.GetTableBuilder().SetSortAttributes(tablename, "RSSI (dBm)", false);
    var curentAdapter = System.Gadget.Settings.read("adapterIndex");
    //System.Debug.outputString("OnShowFlyout(curentAdapter=" + curentAdapter + ")");
    fbuilder.SetOpenAdapterIndex(curentAdapter);

    //fbuilder.SetSkinColors(arrColors);
    var output = fbuilder.BuildFlyout();
    //System.Debug.outputString("OnShowFlyout(curentAdapter set to null)");
    //fbuilder.SetOpenAdapterIndex(null);
    //System.Debug.outputString("wifimonitorjs Builder output = \r\n"+output);   
    // Get the flyout document's element and add the HTML
    var adaptersOutput = theDocument.getElementById('adaptersOutput');

    // Clear the existing UI
    adaptersOutput.innerHTML = output;

    //apply skin colors
    /*
    var adapterHeader = theDocument.getElementById('adapterHeader');
    adapterHeader.style.color = arrColors[1];
    adapterHeader.style.backgroundColor = arrColors[2];
    
    for( var ai =0; ai< wrapi.GetNumWireless; ++ai){
    var adapterBody = theDocument.getElementById('adapterBody'+ai);
    adapterBody.style.color = arrColors[1];
        
    }
    */


}



//var radarRotationEnabled = true;

function isEnableRadarRotation() {
    var enabled = System.Gadget.Settings.read("enableRotation");
    //System.Debug.outputString("isEnableRadarRotation returns "+enabled);
    return enabled;
}

/*
function enableRadarRotation(bEnable)
{
radarRotationEnabled = bEnable;
}
*/

////////////////////////////////////////////
//  prepare settings
////////////////////////////////////////////
function ShowSettings() {

    if (null == wrapi) {
        //System.Debug.outputString("can't show settings");
        return;
    }
    //System.Debug.outputString("ShowSettings");
    System.Gadget.Settings.write("SettingExist", true);
    System.Gadget.Settings.write("adapterIndex", adapterIndex);
    //System.Gadget.Settings.write("displaytypeIndex", displaytypeIndex);

    System.Gadget.Settings.write("enableRotation", isEnableRadarRotation());
    var count = wrapi.GetNumWireless();
    //System.Debug.outputString("ShowSettings: write adapterCount="+count);
    System.Gadget.Settings.write("adapterCount", count);
    for (var i = 0; i < count; i++) {
        var adapterItem = wrapi.GetAdapter(i);
        System.Gadget.Settings.write("adapter" + i, adapterItem.Description);
        //System.Debug.outputString("ShowSettings: write adapter"+i+"="+adapterItem.Description);
    }
}

////////////////////////////////////////////////////////////////////////////////
//
// Read the saved settings
//
////////////////////////////////////////////////////////////////////////////////
function SettingsClosed(event) {

    //System.Debug.outputString("SettingsClosed");
    var exists = System.Gadget.Settings.read("SettingExist");
    //System.Debug.outputString("SettingsClosed SettingExist ="+exists);
    if (exists == true) {

        //var minutes = System.Gadget.Settings.read("frequency");



        //frequency = (OneSecond * 20);

        //backgroundImage.src = 'images/Xirrus-Vista-Gadget.png';
        //config.style.visibility = 'visible';

        // Call ShowWireless since settings have been changed.  
        //var setupText = document.getElementById('setupText');
        var er = System.Gadget.Settings.read("enableRotation");
        //enableRadarRotation(er);
        adapterIndex = System.Gadget.Settings.read("adapterIndex");
        //System.Debug.outputString("SettingsClosed got adapterIndex="+adapterIndex);
        displaytypeIndex = System.Gadget.Settings.read("displaytypeIndex");
        //System.Debug.outputString("SettingsClosed got displaytypeIndex="+displaytypeIndex);

        var enableLocateSound = System.Gadget.Settings.read("enableLocateSound");
        var adapter = wrapi.GetAdapter(adapterIndex);

        try {
            if (adapter.IsLocateMode()) {
                if (0 == enableLocateSound) {
                    //System.Debug.outputString("SettingsClosed: EnableLocateSound(true)");
                    adapter.EnableLocateSound(true);
                } else {
                    //System.Debug.outputString("SettingsClosed: EnableLocateSound(false)");
                    adapter.EnableLocateSound(false);
                }
            }

        } catch (ex) { }
        pollTimeout = System.Gadget.Settings.read("pollTimeout");
        var IntervalMs = GetPoolTimeout(pollTimeout);

        adapter.PoolIntervalMs = IntervalMs;
        wrapi.CheckIntervalMs = IntervalMs;

        wrapi.SetProperty("adapterIndex", adapterIndex.toString());
        wrapi.SetProperty("skinIndex", System.Gadget.Settings.read("skinIndex").toString());

        wrapi.SetProperty("enableRotation", er.toString());
        wrapi.SetProperty("rssiMethod", System.Gadget.Settings.read("rssimethodIndex").toString());

        wrapi.SetProperty("displayUnits", displaytypeIndex.toString());
        wrapi.SetProperty("pollTimeout", pollTimeout.toString());
        wrapi.SetProperty("enableLocateSound", enableLocateSound.toString());



        ShowWireless();

        var _adapterIndex = System.Gadget.Settings.read("adapterIndex");
        var _adapter = wrapi.GetAdapterS("" + _adapterIndex);


        _adapter.ForceImageUpdate();


    }
    else {
        backgroundImage.src = 'images/Xirrus-Vista-Gadget.png';
        config.style.visibility = 'visible';
    }

    event.cancel = false;

}
////////////////////////////////////////////////////////////////////////////////
//
// Check if the gadget is docked or undocked.  Change images and CSS based on 
// the current docked state.
//
////////////////////////////////////////////////////////////////////////////////
function CheckDock() {
    if (!System.Gadget.docked) {
        GadgetUndocked();

    }
    else if (System.Gadget.docked) {
        GadgetDocked();
    }
    try {
        adapterIndex = System.Gadget.Settings.read("adapterIndex");
        adapter = wrapi.GetAdapterS("" + adapterIndex);

        //System.Debug.outputString("dockchange -> force update");
        adapter.ForceImageUpdate();

        ShowWireless();
    } catch (exc) {
    }
}
////////////////////////////////////////////////////////////////////////////////
//
// styles for gadget when undocked
//
////////////////////////////////////////////////////////////////////////////////
function GadgetUndocked() {
    changeBaseImageArray(false);
    with (document.body.style)
        width = 256,
        height = 256;

    with (backgroundImage.style)
        width = 256,
        height = 256,
        top = 0,
        left = 0;

    if (hasWrapi) {
        //System.Debug.outputString("setDocked true");
        wrapi.SetDocked(true, 256, 256);
    }
    with (radarBeam.style)
        width = 149,
        height = 149,
        top = 9,
        left = 9;

    with (setupText)
        className = 'configUndocked';
}

////////////////////////////////////////////////////////////////////////////////
//
// styles for gadget when docked
// 
////////////////////////////////////////////////////////////////////////////////
function GadgetDocked() {
    changeBaseImageArray(true);
    with (document.body.style)
        width = 135,
        height = 135;

    with (backgroundImage.style)
        width = 135,
        height = 135;

    if (hasWrapi) {
        //System.Debug.outputString("setDocked false");
        wrapi.SetDocked(false, 135, 135);
    }

    with (setupText)
        className = 'config';

    with (radarBeam.style)
        width = 135 * 149 / 256 - 1,
        height = 135 * 149 / 256 - 1,
        top = 135 * 9 / 256 + 1,
        left = 135 * 9 / 256 + 1;
}
